/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme.compilation.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import fr.inria.tea.ssme.compilation.Scenario;
import fr.inria.tea.ssme.compilation.ScenarioItem;
import fr.inria.tea.ssme.compilation.SsmeCompPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scenario</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.compilation.impl.ScenarioImpl#getElements <em>Elements</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.compilation.impl.ScenarioImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.compilation.impl.ScenarioImpl#isDisplayWarnings <em>Display Warnings</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ScenarioImpl extends EObjectImpl implements Scenario {
	
	/**
	 * The cached value of the '{@link #getElements() <em>Elements</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElements()
	 * @generated
	 * @ordered
	 */
	protected EList<ScenarioItem> elements;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #isDisplayWarnings() <em>Display Warnings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDisplayWarnings()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DISPLAY_WARNINGS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDisplayWarnings() <em>Display Warnings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDisplayWarnings()
	 * @generated
	 * @ordered
	 */
	protected boolean displayWarnings = DISPLAY_WARNINGS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScenarioImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SsmeCompPackage.Literals.SCENARIO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ScenarioItem> getElements() {
		if (elements == null) {
			elements = new EObjectContainmentEList<ScenarioItem>(ScenarioItem.class, this, SsmeCompPackage.SCENARIO__ELEMENTS);
		}
		return elements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmeCompPackage.SCENARIO__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDisplayWarnings() {
		return displayWarnings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisplayWarnings(boolean newDisplayWarnings) {
		boolean oldDisplayWarnings = displayWarnings;
		displayWarnings = newDisplayWarnings;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmeCompPackage.SCENARIO__DISPLAY_WARNINGS, oldDisplayWarnings, displayWarnings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SsmeCompPackage.SCENARIO__ELEMENTS:
				return ((InternalEList<?>)getElements()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SsmeCompPackage.SCENARIO__ELEMENTS:
				return getElements();
			case SsmeCompPackage.SCENARIO__DESCRIPTION:
				return getDescription();
			case SsmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				return isDisplayWarnings();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SsmeCompPackage.SCENARIO__ELEMENTS:
				getElements().clear();
				getElements().addAll((Collection<? extends ScenarioItem>)newValue);
				return;
			case SsmeCompPackage.SCENARIO__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case SsmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				setDisplayWarnings((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SsmeCompPackage.SCENARIO__ELEMENTS:
				getElements().clear();
				return;
			case SsmeCompPackage.SCENARIO__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case SsmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				setDisplayWarnings(DISPLAY_WARNINGS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SsmeCompPackage.SCENARIO__ELEMENTS:
				return elements != null && !elements.isEmpty();
			case SsmeCompPackage.SCENARIO__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case SsmeCompPackage.SCENARIO__DISPLAY_WARNINGS:
				return displayWarnings != DISPLAY_WARNINGS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", displayWarnings: ");
		result.append(displayWarnings);
		result.append(')');
		return result.toString();
	}

} //ScenarioImpl
