/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Array Elements Enumeration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.ArrayElementsEnumeration#getListPartialArrayDefinition <em>List Partial Array Definition</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getArrayElementsEnumeration()
 * @model
 * @generated
 */
public interface ArrayElementsEnumeration extends IterativeEnumeration {
	/**
	 * Returns the value of the '<em><b>List Partial Array Definition</b></em>' containment reference list.
	 * The list contents are of type {@link fr.inria.tea.ssme.PartialArrayDefinition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>List Partial Array Definition</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>List Partial Array Definition</em>' containment reference list.
	 * @see fr.inria.tea.ssme.SsmePackage#getArrayElementsEnumeration_ListPartialArrayDefinition()
	 * @model containment="true"
	 * @generated
	 */
	EList<PartialArrayDefinition> getListPartialArrayDefinition();

} // ArrayElementsEnumeration
