/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Array Process</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.ArrayProcess#getArrayIndex <em>Array Index</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ArrayProcess#getExprProcess <em>Expr Process</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ArrayProcess#getIterationInit <em>Iteration Init</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getArrayProcess()
 * @model
 * @generated
 */
public interface ArrayProcess extends IterationOfProcesses {
	/**
	 * Returns the value of the '<em><b>Array Index</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Array Index</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Array Index</em>' containment reference.
	 * @see #setArrayIndex(ArrayIndex)
	 * @see fr.inria.tea.ssme.SsmePackage#getArrayProcess_ArrayIndex()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ArrayIndex getArrayIndex();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ArrayProcess#getArrayIndex <em>Array Index</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Array Index</em>' containment reference.
	 * @see #getArrayIndex()
	 * @generated
	 */
	void setArrayIndex(ArrayIndex value);

	/**
	 * Returns the value of the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expr Process</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expr Process</em>' containment reference.
	 * @see #setExprProcess(ExprProcess)
	 * @see fr.inria.tea.ssme.SsmePackage#getArrayProcess_ExprProcess()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ExprProcess getExprProcess();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ArrayProcess#getExprProcess <em>Expr Process</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Expr Process</em>' containment reference.
	 * @see #getExprProcess()
	 * @generated
	 */
	void setExprProcess(ExprProcess value);

	/**
	 * Returns the value of the '<em><b>Iteration Init</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Iteration Init</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Iteration Init</em>' containment reference.
	 * @see #setIterationInit(ExprProcess)
	 * @see fr.inria.tea.ssme.SsmePackage#getArrayProcess_IterationInit()
	 * @model containment="true"
	 * @generated
	 */
	ExprProcess getIterationInit();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ArrayProcess#getIterationInit <em>Iteration Init</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Iteration Init</em>' containment reference.
	 * @see #getIterationInit()
	 * @generated
	 */
	void setIterationInit(ExprProcess value);

} // ArrayProcess
