/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Composition</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.Composition#getListExprProcess <em>List Expr Process</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getComposition()
 * @model annotation="http://www.topcased.org/uuid uuid='_2LOfQO5WEduz9o2pAin6-g'"
 * @generated
 */
public interface Composition extends ExprProcess {
	/**
	 * Returns the value of the '<em><b>List Expr Process</b></em>' containment reference list.
	 * The list contents are of type {@link fr.inria.tea.ssme.ExprProcess}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>List Expr Process</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>List Expr Process</em>' containment reference list.
	 * @see fr.inria.tea.ssme.SsmePackage#getComposition_ListExprProcess()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<ExprProcess> getListExprProcess();

} // Composition
