/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Constants Declaration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.ConstantsDeclaration#getVisibility <em>Visibility</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ConstantsDeclaration#getType <em>Type</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ConstantsDeclaration#getListConstantDefinition <em>List Constant Definition</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getConstantsDeclaration()
 * @model
 * @generated
 */
public interface ConstantsDeclaration extends Declaration {
	/**
	 * Returns the value of the '<em><b>Visibility</b></em>' attribute.
	 * The literals are from the enumeration {@link fr.inria.tea.ssme.VisibilityKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visibility</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Visibility</em>' attribute.
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @see #setVisibility(VisibilityKind)
	 * @see fr.inria.tea.ssme.SsmePackage#getConstantsDeclaration_Visibility()
	 * @model required="true"
	 * @generated
	 */
	VisibilityKind getVisibility();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ConstantsDeclaration#getVisibility <em>Visibility</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Visibility</em>' attribute.
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @see #getVisibility()
	 * @generated
	 */
	void setVisibility(VisibilityKind value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' containment reference.
	 * @see #setType(Type)
	 * @see fr.inria.tea.ssme.SsmePackage#getConstantsDeclaration_Type()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Type getType();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ConstantsDeclaration#getType <em>Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' containment reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(Type value);

	/**
	 * Returns the value of the '<em><b>List Constant Definition</b></em>' containment reference list.
	 * The list contents are of type {@link fr.inria.tea.ssme.ConstantDefinition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>List Constant Definition</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>List Constant Definition</em>' containment reference list.
	 * @see fr.inria.tea.ssme.SsmePackage#getConstantsDeclaration_ListConstantDefinition()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<ConstantDefinition> getListConstantDefinition();

} // ConstantsDeclaration
