/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Process Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.ProcessModel#getIdentifier <em>Identifier</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ProcessModel#getInterfaceDefinition <em>Interface Definition</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ProcessModel#getDescription <em>Description</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ProcessModel#getModelKind <em>Model Kind</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.ProcessModel#getVisibilityKind <em>Visibility Kind</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel()
 * @model
 * @generated
 */
public interface ProcessModel extends SignalElement, ProcessDeclaration {
	/**
	 * Returns the value of the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Identifier</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Identifier</em>' containment reference.
	 * @see #setIdentifier(Identifier)
	 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel_Identifier()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Identifier getIdentifier();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ProcessModel#getIdentifier <em>Identifier</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Identifier</em>' containment reference.
	 * @see #getIdentifier()
	 * @generated
	 */
	void setIdentifier(Identifier value);

	/**
	 * Returns the value of the '<em><b>Interface Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Definition</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Definition</em>' containment reference.
	 * @see #setInterfaceDefinition(InterfaceDefinition)
	 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel_InterfaceDefinition()
	 * @model containment="true" required="true"
	 * @generated
	 */
	InterfaceDefinition getInterfaceDefinition();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ProcessModel#getInterfaceDefinition <em>Interface Definition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Definition</em>' containment reference.
	 * @see #getInterfaceDefinition()
	 * @generated
	 */
	void setInterfaceDefinition(InterfaceDefinition value);

	/**
	 * Returns the value of the '<em><b>Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' containment reference.
	 * @see #setDescription(Description)
	 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel_Description()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Description getDescription();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ProcessModel#getDescription <em>Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' containment reference.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(Description value);

	/**
	 * Returns the value of the '<em><b>Model Kind</b></em>' attribute.
	 * The literals are from the enumeration {@link fr.inria.tea.ssme.ModelKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Kind</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Kind</em>' attribute.
	 * @see fr.inria.tea.ssme.ModelKind
	 * @see #setModelKind(ModelKind)
	 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel_ModelKind()
	 * @model required="true"
	 * @generated
	 */
	ModelKind getModelKind();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ProcessModel#getModelKind <em>Model Kind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Kind</em>' attribute.
	 * @see fr.inria.tea.ssme.ModelKind
	 * @see #getModelKind()
	 * @generated
	 */
	void setModelKind(ModelKind value);

	/**
	 * Returns the value of the '<em><b>Visibility Kind</b></em>' attribute.
	 * The literals are from the enumeration {@link fr.inria.tea.ssme.VisibilityKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visibility Kind</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Visibility Kind</em>' attribute.
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @see #setVisibilityKind(VisibilityKind)
	 * @see fr.inria.tea.ssme.SsmePackage#getProcessModel_VisibilityKind()
	 * @model required="true"
	 * @generated
	 */
	VisibilityKind getVisibilityKind();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.ProcessModel#getVisibilityKind <em>Visibility Kind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Visibility Kind</em>' attribute.
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @see #getVisibilityKind()
	 * @generated
	 */
	void setVisibilityKind(VisibilityKind value);

} // ProcessModel
