/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Ternary Operators</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal1 <em>Expr Signal1</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal2 <em>Expr Signal2</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal3 <em>Expr Signal3</em>}</li>
 * </ul>
 *
 * @see fr.inria.tea.ssme.SsmePackage#getTernaryOperators()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface TernaryOperators extends ExprSignal {
	/**
	 * Returns the value of the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expr Signal1</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expr Signal1</em>' containment reference.
	 * @see #setExprSignal1(ExprSignal)
	 * @see fr.inria.tea.ssme.SsmePackage#getTernaryOperators_ExprSignal1()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ExprSignal getExprSignal1();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal1 <em>Expr Signal1</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Expr Signal1</em>' containment reference.
	 * @see #getExprSignal1()
	 * @generated
	 */
	void setExprSignal1(ExprSignal value);

	/**
	 * Returns the value of the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expr Signal2</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expr Signal2</em>' containment reference.
	 * @see #setExprSignal2(ExprSignal)
	 * @see fr.inria.tea.ssme.SsmePackage#getTernaryOperators_ExprSignal2()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ExprSignal getExprSignal2();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal2 <em>Expr Signal2</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Expr Signal2</em>' containment reference.
	 * @see #getExprSignal2()
	 * @generated
	 */
	void setExprSignal2(ExprSignal value);

	/**
	 * Returns the value of the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Expr Signal3</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Expr Signal3</em>' containment reference.
	 * @see #setExprSignal3(ExprSignal)
	 * @see fr.inria.tea.ssme.SsmePackage#getTernaryOperators_ExprSignal3()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ExprSignal getExprSignal3();

	/**
	 * Sets the value of the '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal3 <em>Expr Signal3</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Expr Signal3</em>' containment reference.
	 * @see #getExprSignal3()
	 * @generated
	 */
	void setExprSignal3(ExprSignal value);

} // TernaryOperators
