/**
 */
package fr.inria.tea.ssme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.inria.tea.ssme.ControlledProcess;
import fr.inria.tea.ssme.ExprProcess;
import fr.inria.tea.ssme.ExprSignal;
import fr.inria.tea.ssme.SsmePackage;

import fr.inria.tea.ssme.polychrony.PKTrees;
import fr.inria.tea.ssme.polychrony.PkPlugin;
import fr.inria.tea.ssme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Controlled Process</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link fr.inria.tea.ssme.impl.ControlledProcessImpl#getExprSignal
 * <em>Expr Signal</em>}</li>
 * <li>{@link fr.inria.tea.ssme.impl.ControlledProcessImpl#getExprProcess
 * <em>Expr Process</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ControlledProcessImpl extends SignalElementImpl implements ControlledProcess {
	/**
	 * The cached value of the '{@link #getExprSignal() <em>Expr Signal</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExprSignal()
	 * @generated
	 * @ordered
	 */
	protected ExprSignal exprSignal;

	/**
	 * The cached value of the '{@link #getExprProcess() <em>Expr Process</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExprProcess()
	 * @generated
	 * @ordered
	 */
	protected ExprProcess exprProcess;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ControlledProcessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SsmePackage.eINSTANCE.getControlledProcess();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ExprSignal getExprSignal() {
		return exprSignal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetExprSignal(ExprSignal newExprSignal, NotificationChain msgs) {
		ExprSignal oldExprSignal = exprSignal;
		exprSignal = newExprSignal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL, oldExprSignal, newExprSignal);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setExprSignal(ExprSignal newExprSignal) {
		if (newExprSignal != exprSignal) {
			NotificationChain msgs = null;
			if (exprSignal != null)
				msgs = ((InternalEObject) exprSignal).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL, null, msgs);
			if (newExprSignal != null)
				msgs = ((InternalEObject) newExprSignal).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL, null, msgs);
			msgs = basicSetExprSignal(newExprSignal, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL,
					newExprSignal, newExprSignal));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ExprProcess getExprProcess() {
		return exprProcess;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetExprProcess(ExprProcess newExprProcess, NotificationChain msgs) {
		ExprProcess oldExprProcess = exprProcess;
		exprProcess = newExprProcess;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS, oldExprProcess, newExprProcess);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setExprProcess(ExprProcess newExprProcess) {
		if (newExprProcess != exprProcess) {
			NotificationChain msgs = null;
			if (exprProcess != null)
				msgs = ((InternalEObject) exprProcess).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS, null, msgs);
			if (newExprProcess != null)
				msgs = ((InternalEObject) newExprProcess).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS, null, msgs);
			msgs = basicSetExprProcess(newExprProcess, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS,
					newExprProcess, newExprProcess));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL:
			return basicSetExprSignal(null, msgs);
		case SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS:
			return basicSetExprProcess(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL:
			return getExprSignal();
		case SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS:
			return getExprProcess();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL:
			setExprSignal((ExprSignal) newValue);
			return;
		case SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS:
			setExprProcess((ExprProcess) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL:
			setExprSignal((ExprSignal) null);
			return;
		case SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS:
			setExprProcess((ExprProcess) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case SsmePackage.CONTROLLED_PROCESS__EXPR_SIGNAL:
			return exprSignal != null;
		case SsmePackage.CONTROLLED_PROCESS__EXPR_PROCESS:
			return exprProcess != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public long makeAST() { // on ESIG :: EPROC
		long result, child1, child2;
		PKTrees API = PkPlugin.getTreeAPI();
		ExprSignal esig = getExprSignal();
		if (esig != null)
			child1 = esig.makeAST();
		else
			child1 = API.getNilTree();

		ExprProcess eproc = getExprProcess();
		if (eproc != null)
			child2 = eproc.makeAST();
		else
			child2 = API.getNilTree();
		if (API.isNilTree(child2))
			result = API.getNilTree();
		else if ((child1 != PKTrees.ERROR_NODE) && (child2 != PKTrees.ERROR_NODE))
			result = API.makeBinary(SignalOperators.oppcontrol, child1, child2);
		else
			result = PKTrees.ERROR_NODE;
		setASTAttribute(this, result);
		return result;
	}
} // ControlledProcessImpl
