/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import fr.inria.tea.ssme.Conversion;
import fr.inria.tea.ssme.ExprSignal;
import fr.inria.tea.ssme.PredefinedType;
import fr.inria.tea.ssme.SsmePackage;
import fr.inria.tea.ssme.polychrony.PKTrees;
import fr.inria.tea.ssme.polychrony.PkPlugin;
import fr.inria.tea.ssme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Conversion</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.impl.ConversionImpl#getPredefinedType <em>Predefined Type</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.impl.ConversionImpl#getExprSignal <em>Expr Signal</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConversionImpl extends SignalElementImpl implements Conversion {
	/**
	 * The cached value of the '{@link #getPredefinedType() <em>Predefined Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPredefinedType()
	 * @generated
	 * @ordered
	 */
	protected PredefinedType predefinedType;

	/**
	 * The cached value of the '{@link #getExprSignal() <em>Expr Signal</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExprSignal()
	 * @generated
	 * @ordered
	 */
	protected ExprSignal exprSignal;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConversionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SsmePackage.eINSTANCE.getConversion();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedType getPredefinedType() {
		return predefinedType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredefinedType(PredefinedType newPredefinedType, NotificationChain msgs) {
		PredefinedType oldPredefinedType = predefinedType;
		predefinedType = newPredefinedType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.CONVERSION__PREDEFINED_TYPE, oldPredefinedType, newPredefinedType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPredefinedType(PredefinedType newPredefinedType) {
		if (newPredefinedType != predefinedType) {
			NotificationChain msgs = null;
			if (predefinedType != null)
				msgs = ((InternalEObject)predefinedType).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.CONVERSION__PREDEFINED_TYPE, null, msgs);
			if (newPredefinedType != null)
				msgs = ((InternalEObject)newPredefinedType).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.CONVERSION__PREDEFINED_TYPE, null, msgs);
			msgs = basicSetPredefinedType(newPredefinedType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.CONVERSION__PREDEFINED_TYPE, newPredefinedType, newPredefinedType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExprSignal getExprSignal() {
		return exprSignal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExprSignal(ExprSignal newExprSignal, NotificationChain msgs) {
		ExprSignal oldExprSignal = exprSignal;
		exprSignal = newExprSignal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.CONVERSION__EXPR_SIGNAL, oldExprSignal, newExprSignal);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExprSignal(ExprSignal newExprSignal) {
		if (newExprSignal != exprSignal) {
			NotificationChain msgs = null;
			if (exprSignal != null)
				msgs = ((InternalEObject)exprSignal).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.CONVERSION__EXPR_SIGNAL, null, msgs);
			if (newExprSignal != null)
				msgs = ((InternalEObject)newExprSignal).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.CONVERSION__EXPR_SIGNAL, null, msgs);
			msgs = basicSetExprSignal(newExprSignal, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.CONVERSION__EXPR_SIGNAL, newExprSignal, newExprSignal));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public long makeAST() {
		PKTrees API = PkPlugin.getTreeAPI();
		long result = PKTrees.ERROR_NODE;
		long typeNode = API.getNilTree();
		if (getPredefinedType() != null) {
			typeNode = getPredefinedType().makeAST();
		}
		long exprSignalNode = API.getNilTree();
		if (getExprSignal() != null) {
			exprSignalNode = getExprSignal().makeAST();
		}
		if (typeNode != PKTrees.ERROR_NODE && exprSignalNode != PKTrees.ERROR_NODE) {
			result = API.makeBinary(SignalOperators.opconv, typeNode, exprSignalNode);
		}
		setASTAttribute(this, result);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SsmePackage.CONVERSION__PREDEFINED_TYPE:
				return basicSetPredefinedType(null, msgs);
			case SsmePackage.CONVERSION__EXPR_SIGNAL:
				return basicSetExprSignal(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SsmePackage.CONVERSION__PREDEFINED_TYPE:
				return getPredefinedType();
			case SsmePackage.CONVERSION__EXPR_SIGNAL:
				return getExprSignal();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SsmePackage.CONVERSION__PREDEFINED_TYPE:
				setPredefinedType((PredefinedType)newValue);
				return;
			case SsmePackage.CONVERSION__EXPR_SIGNAL:
				setExprSignal((ExprSignal)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SsmePackage.CONVERSION__PREDEFINED_TYPE:
				setPredefinedType((PredefinedType)null);
				return;
			case SsmePackage.CONVERSION__EXPR_SIGNAL:
				setExprSignal((ExprSignal)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SsmePackage.CONVERSION__PREDEFINED_TYPE:
				return predefinedType != null;
			case SsmePackage.CONVERSION__EXPR_SIGNAL:
				return exprSignal != null;
		}
		return super.eIsSet(featureID);
	}

} //ConversionImpl
