/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import fr.inria.tea.ssme.ElemDefinition;
import fr.inria.tea.ssme.ExprSignal;
import fr.inria.tea.ssme.ListExprSignal;
import fr.inria.tea.ssme.SsmePackage;
import fr.inria.tea.ssme.polychrony.PKTrees;
import fr.inria.tea.ssme.polychrony.PkPlugin;
import fr.inria.tea.ssme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Elem Definition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.impl.ElemDefinitionImpl#getExprDimension <em>Expr Dimension</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.impl.ElemDefinitionImpl#getExprSignal <em>Expr Signal</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ElemDefinitionImpl extends SignalElementImpl implements ElemDefinition {
	/**
	 * The cached value of the '{@link #getExprDimension() <em>Expr Dimension</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExprDimension()
	 * @generated
	 * @ordered
	 */
	protected ListExprSignal exprDimension;

	/**
	 * The cached value of the '{@link #getExprSignal() <em>Expr Signal</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExprSignal()
	 * @generated
	 * @ordered
	 */
	protected ExprSignal exprSignal;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElemDefinitionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SsmePackage.eINSTANCE.getElemDefinition();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ListExprSignal getExprDimension() {
		return exprDimension;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExprDimension(ListExprSignal newExprDimension, NotificationChain msgs) {
		ListExprSignal oldExprDimension = exprDimension;
		exprDimension = newExprDimension;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION, oldExprDimension, newExprDimension);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExprDimension(ListExprSignal newExprDimension) {
		if (newExprDimension != exprDimension) {
			NotificationChain msgs = null;
			if (exprDimension != null)
				msgs = ((InternalEObject)exprDimension).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION, null, msgs);
			if (newExprDimension != null)
				msgs = ((InternalEObject)newExprDimension).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION, null, msgs);
			msgs = basicSetExprDimension(newExprDimension, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION, newExprDimension, newExprDimension));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExprSignal getExprSignal() {
		return exprSignal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExprSignal(ExprSignal newExprSignal, NotificationChain msgs) {
		ExprSignal oldExprSignal = exprSignal;
		exprSignal = newExprSignal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL, oldExprSignal, newExprSignal);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExprSignal(ExprSignal newExprSignal) {
		if (newExprSignal != exprSignal) {
			NotificationChain msgs = null;
			if (exprSignal != null)
				msgs = ((InternalEObject)exprSignal).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL, null, msgs);
			if (newExprSignal != null)
				msgs = ((InternalEObject)newExprSignal).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL, null, msgs);
			msgs = basicSetExprSignal(newExprSignal, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL, newExprSignal, newExprSignal));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION:
				return basicSetExprDimension(null, msgs);
			case SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL:
				return basicSetExprSignal(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION:
				return getExprDimension();
			case SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL:
				return getExprSignal();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION:
				setExprDimension((ListExprSignal)newValue);
				return;
			case SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL:
				setExprSignal((ExprSignal)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION:
				setExprDimension((ListExprSignal)null);
				return;
			case SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL:
				setExprSignal((ExprSignal)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SsmePackage.ELEM_DEFINITION__EXPR_DIMENSION:
				return exprDimension != null;
			case SsmePackage.ELEM_DEFINITION__EXPR_SIGNAL:
				return exprSignal != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public long makeAST() {
		PKTrees API = PkPlugin.getTreeAPI();
		long result = PKTrees.ERROR_NODE;
		
		long listESig = API.getNilTree();
		if (getExprDimension() != null && !getExprDimension().getExprSignal().isEmpty()) {
			listESig = getExprDimension().makeAST();
		}
		
		long eSigNode = API.getNilTree();
		if (getExprSignal() != null) {
			eSigNode = getExprSignal().makeAST();
		}
		
		if (listESig != PKTrees.ERROR_NODE && eSigNode != PKTrees.ERROR_NODE) {
			result = API.makeBinary(SignalOperators.opelevec, listESig, eSigNode);
		}
		setASTAttribute(this, result);
		return result;
	}

} //ElemDefinitionImpl
