/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import fr.inria.tea.ssme.ExprSignal;
import fr.inria.tea.ssme.Identifier;
import fr.inria.tea.ssme.SsmePackage;
import fr.inria.tea.ssme.TypeDescription;
import fr.inria.tea.ssme.TypeDescriptionValue;
import fr.inria.tea.ssme.polychrony.PKTrees;
import fr.inria.tea.ssme.polychrony.PkPlugin;
import fr.inria.tea.ssme.polychrony.SignalOperators;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Type Description</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.inria.tea.ssme.impl.TypeDescriptionImpl#getIdentifier <em>Identifier</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.impl.TypeDescriptionImpl#getTypeDescriptionValue <em>Type Description Value</em>}</li>
 *   <li>{@link fr.inria.tea.ssme.impl.TypeDescriptionImpl#getInitValue <em>Init Value</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TypeDescriptionImpl extends SignalElementImpl implements TypeDescription {
	/**
	 * The cached value of the '{@link #getIdentifier() <em>Identifier</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIdentifier()
	 * @generated
	 * @ordered
	 */
	protected Identifier identifier;

	/**
	 * The cached value of the '{@link #getTypeDescriptionValue() <em>Type Description Value</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeDescriptionValue()
	 * @generated
	 * @ordered
	 */
	protected TypeDescriptionValue typeDescriptionValue;

	/**
	 * The cached value of the '{@link #getInitValue() <em>Init Value</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitValue()
	 * @generated
	 * @ordered
	 */
	protected ExprSignal initValue;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeDescriptionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SsmePackage.eINSTANCE.getTypeDescription();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Identifier getIdentifier() {
		return identifier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIdentifier(Identifier newIdentifier, NotificationChain msgs) {
		Identifier oldIdentifier = identifier;
		identifier = newIdentifier;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__IDENTIFIER, oldIdentifier, newIdentifier);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIdentifier(Identifier newIdentifier) {
		if (newIdentifier != identifier) {
			NotificationChain msgs = null;
			if (identifier != null)
				msgs = ((InternalEObject)identifier).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__IDENTIFIER, null, msgs);
			if (newIdentifier != null)
				msgs = ((InternalEObject)newIdentifier).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__IDENTIFIER, null, msgs);
			msgs = basicSetIdentifier(newIdentifier, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__IDENTIFIER, newIdentifier, newIdentifier));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeDescriptionValue getTypeDescriptionValue() {
		return typeDescriptionValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTypeDescriptionValue(TypeDescriptionValue newTypeDescriptionValue, NotificationChain msgs) {
		TypeDescriptionValue oldTypeDescriptionValue = typeDescriptionValue;
		typeDescriptionValue = newTypeDescriptionValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE, oldTypeDescriptionValue, newTypeDescriptionValue);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTypeDescriptionValue(TypeDescriptionValue newTypeDescriptionValue) {
		if (newTypeDescriptionValue != typeDescriptionValue) {
			NotificationChain msgs = null;
			if (typeDescriptionValue != null)
				msgs = ((InternalEObject)typeDescriptionValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE, null, msgs);
			if (newTypeDescriptionValue != null)
				msgs = ((InternalEObject)newTypeDescriptionValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE, null, msgs);
			msgs = basicSetTypeDescriptionValue(newTypeDescriptionValue, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE, newTypeDescriptionValue, newTypeDescriptionValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExprSignal getInitValue() {
		return initValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInitValue(ExprSignal newInitValue, NotificationChain msgs) {
		ExprSignal oldInitValue = initValue;
		initValue = newInitValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__INIT_VALUE, oldInitValue, newInitValue);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInitValue(ExprSignal newInitValue) {
		if (newInitValue != initValue) {
			NotificationChain msgs = null;
			if (initValue != null)
				msgs = ((InternalEObject)initValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__INIT_VALUE, null, msgs);
			if (newInitValue != null)
				msgs = ((InternalEObject)newInitValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SsmePackage.TYPE_DESCRIPTION__INIT_VALUE, null, msgs);
			msgs = basicSetInitValue(newInitValue, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SsmePackage.TYPE_DESCRIPTION__INIT_VALUE, newInitValue, newInitValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case SsmePackage.TYPE_DESCRIPTION__IDENTIFIER:
				return basicSetIdentifier(null, msgs);
			case SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE:
				return basicSetTypeDescriptionValue(null, msgs);
			case SsmePackage.TYPE_DESCRIPTION__INIT_VALUE:
				return basicSetInitValue(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SsmePackage.TYPE_DESCRIPTION__IDENTIFIER:
				return getIdentifier();
			case SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE:
				return getTypeDescriptionValue();
			case SsmePackage.TYPE_DESCRIPTION__INIT_VALUE:
				return getInitValue();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SsmePackage.TYPE_DESCRIPTION__IDENTIFIER:
				setIdentifier((Identifier)newValue);
				return;
			case SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE:
				setTypeDescriptionValue((TypeDescriptionValue)newValue);
				return;
			case SsmePackage.TYPE_DESCRIPTION__INIT_VALUE:
				setInitValue((ExprSignal)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SsmePackage.TYPE_DESCRIPTION__IDENTIFIER:
				setIdentifier((Identifier)null);
				return;
			case SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE:
				setTypeDescriptionValue((TypeDescriptionValue)null);
				return;
			case SsmePackage.TYPE_DESCRIPTION__INIT_VALUE:
				setInitValue((ExprSignal)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SsmePackage.TYPE_DESCRIPTION__IDENTIFIER:
				return identifier != null;
			case SsmePackage.TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE:
				return typeDescriptionValue != null;
			case SsmePackage.TYPE_DESCRIPTION__INIT_VALUE:
				return initValue != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public long makeAST() {
		PKTrees API = PkPlugin.getTreeAPI();
		long result = PKTrees.ERROR_NODE;
		
		long identNode = API.getNilTree();
		if (getIdentifier() != null) {
			identNode = getIdentifier().makeAST();
		}
		
		long valeurTypeNode = API.getNilTree();
		if (getTypeDescriptionValue() != null) {
			valeurTypeNode = getTypeDescriptionValue().makeAST();
		}
		
		long initNode = API.getNilTree();
		if (getInitValue() != null) {
			initNode = getInitValue().makeAST();
		}
		
		if (identNode != PKTrees.ERROR_NODE && valeurTypeNode != PKTrees.ERROR_NODE && initNode != PKTrees.ERROR_NODE) {
			result = API.makeTernary(SignalOperators.optype, identNode, valeurTypeNode, initNode);
		}
		setASTAttribute(this, result);
		return result;
	}

} //TypeDescriptionImpl
