/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package fr.inria.tea.ssme;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.inria.tea.ssme.SsmeFactory
 * @model kind="package"
 * @generated
 */
public interface SsmePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "ssme";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.irisa.fr/espresso/ssme.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "ssme";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SsmePackage eINSTANCE = fr.inria.tea.ssme.impl.SsmePackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalElementImpl <em>Signal Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalElementImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalElement()
	 * @generated
	 */
	int SIGNAL_ELEMENT = 130;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_ELEMENT__COMMENT_PRE = 0;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_ELEMENT__COMMENT_POST = 1;

	/**
	 * The number of structural features of the '<em>Signal Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_ELEMENT_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ExprSignal <em>Expr Signal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ExprSignal
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExprSignal()
	 * @generated
	 */
	int EXPR_SIGNAL = 62;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_SIGNAL__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_SIGNAL__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Expr Signal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_SIGNAL_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.BinaryOperators <em>Binary Operators</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.BinaryOperators
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getBinaryOperators()
	 * @generated
	 */
	int BINARY_OPERATORS = 11;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OPERATORS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OPERATORS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OPERATORS__EXPR_SIGNAL1 = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OPERATORS__EXPR_SIGNAL2 = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Binary Operators</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_OPERATORS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.AfterImpl <em>After</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.AfterImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getAfter()
	 * @generated
	 */
	int AFTER = 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFTER__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFTER__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFTER__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFTER__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>After</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AFTER_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.AndImpl <em>And</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.AndImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getAnd()
	 * @generated
	 */
	int AND = 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>And</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayElemImpl <em>Array Elem</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayElemImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayElem()
	 * @generated
	 */
	int ARRAY_ELEM = 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEM__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEM__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEM__EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEM__LIST_EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Elem</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEM_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.IterativeEnumeration <em>Iterative Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.IterativeEnumeration
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIterativeEnumeration()
	 * @generated
	 */
	int ITERATIVE_ENUMERATION = 81;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATIVE_ENUMERATION__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATIVE_ENUMERATION__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Iterative Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATIVE_ENUMERATION_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayElementsEnumerationImpl <em>Array Elements Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayElementsEnumerationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayElementsEnumeration()
	 * @generated
	 */
	int ARRAY_ELEMENTS_ENUMERATION = 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEMENTS_ENUMERATION__COMMENT_PRE = ITERATIVE_ENUMERATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEMENTS_ENUMERATION__COMMENT_POST = ITERATIVE_ENUMERATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Partial Array Definition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEMENTS_ENUMERATION__LIST_PARTIAL_ARRAY_DEFINITION = ITERATIVE_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Array Elements Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_ELEMENTS_ENUMERATION_FEATURE_COUNT = ITERATIVE_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayIndexImpl <em>Array Index</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayIndexImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayIndex()
	 * @generated
	 */
	int ARRAY_INDEX = 4;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_INDEX__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_INDEX__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_INDEX__IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_INDEX__UPPER_BOUND = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Index</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_INDEX_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ExprProcess <em>Expr Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ExprProcess
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExprProcess()
	 * @generated
	 */
	int EXPR_PROCESS = 61;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PROCESS__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PROCESS__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Expr Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PROCESS_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.IterationOfProcesses <em>Iteration Of Processes</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.IterationOfProcesses
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIterationOfProcesses()
	 * @generated
	 */
	int ITERATION_OF_PROCESSES = 79;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_OF_PROCESSES__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_OF_PROCESSES__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Iteration Of Processes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_OF_PROCESSES_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayProcessImpl <em>Array Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayProcess()
	 * @generated
	 */
	int ARRAY_PROCESS = 5;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS__COMMENT_PRE = ITERATION_OF_PROCESSES__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS__COMMENT_POST = ITERATION_OF_PROCESSES__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Array Index</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS__ARRAY_INDEX = ITERATION_OF_PROCESSES_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS__EXPR_PROCESS = ITERATION_OF_PROCESSES_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Iteration Init</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS__ITERATION_INIT = ITERATION_OF_PROCESSES_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Array Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PROCESS_FEATURE_COUNT = ITERATION_OF_PROCESSES_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayProductImpl <em>Array Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayProductImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayProduct()
	 * @generated
	 */
	int ARRAY_PRODUCT = 6;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PRODUCT__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PRODUCT__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PRODUCT__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PRODUCT__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Array Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_PRODUCT_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayRestructurationImpl <em>Array Restructuration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayRestructurationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayRestructuration()
	 * @generated
	 */
	int ARRAY_RESTRUCTURATION = 7;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RESTRUCTURATION__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RESTRUCTURATION__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RESTRUCTURATION__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RESTRUCTURATION__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Array Restructuration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_RESTRUCTURATION_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.TypeDescriptionValue <em>Type Description Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.TypeDescriptionValue
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypeDescriptionValue()
	 * @generated
	 */
	int TYPE_DESCRIPTION_VALUE = 146;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION_VALUE__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION_VALUE__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Type Description Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION_VALUE_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.Type <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.Type
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getType()
	 * @generated
	 */
	int TYPE = 143;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__COMMENT_PRE = TYPE_DESCRIPTION_VALUE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__COMMENT_POST = TYPE_DESCRIPTION_VALUE__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_FEATURE_COUNT = TYPE_DESCRIPTION_VALUE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.DescribedType <em>Described Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.DescribedType
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDescribedType()
	 * @generated
	 */
	int DESCRIBED_TYPE = 52;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIBED_TYPE__COMMENT_PRE = TYPE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIBED_TYPE__COMMENT_POST = TYPE__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Described Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIBED_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ArrayTypeImpl <em>Array Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ArrayTypeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getArrayType()
	 * @generated
	 */
	int ARRAY_TYPE = 8;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE__COMMENT_PRE = DESCRIBED_TYPE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE__COMMENT_POST = DESCRIBED_TYPE__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Dimension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE__EXPR_DIMENSION = DESCRIBED_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE__TYPE = DESCRIBED_TYPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Array Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARRAY_TYPE_FEATURE_COUNT = DESCRIBED_TYPE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.AssertProcessImpl <em>Assert Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.AssertProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getAssertProcess()
	 * @generated
	 */
	int ASSERT_PROCESS = 9;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_PROCESS__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_PROCESS__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Process Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_PROCESS__PROCESS_EXPRESSION = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Assert Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_PROCESS_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ProcessCallOrAssert <em>Process Call Or Assert</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ProcessCallOrAssert
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessCallOrAssert()
	 * @generated
	 */
	int PROCESS_CALL_OR_ASSERT = 115;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL_OR_ASSERT__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL_OR_ASSERT__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Process Call Or Assert</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL_OR_ASSERT_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.AssertSignalImpl <em>Assert Signal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.AssertSignalImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getAssertSignal()
	 * @generated
	 */
	int ASSERT_SIGNAL = 10;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_SIGNAL__COMMENT_PRE = PROCESS_CALL_OR_ASSERT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_SIGNAL__COMMENT_POST = PROCESS_CALL_OR_ASSERT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_SIGNAL__EXPR_SIGNAL = PROCESS_CALL_OR_ASSERT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Assert Signal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSERT_SIGNAL_FEATURE_COUNT = PROCESS_CALL_OR_ASSERT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.BoundsImpl <em>Bounds</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.BoundsImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getBounds()
	 * @generated
	 */
	int BOUNDS = 12;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS__LOWER_BOUND = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS__UPPER_BOUND = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Step</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS__STEP = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Bounds</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOUNDS_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CartesianProductImpl <em>Cartesian Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CartesianProductImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCartesianProduct()
	 * @generated
	 */
	int CARTESIAN_PRODUCT = 13;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARTESIAN_PRODUCT__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARTESIAN_PRODUCT__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARTESIAN_PRODUCT__LIST_EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Cartesian Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CARTESIAN_PRODUCT_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.CaseExprEnumeration <em>Case Expr Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.CaseExprEnumeration
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCaseExprEnumeration()
	 * @generated
	 */
	int CASE_EXPR_ENUMERATION = 15;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_EXPR_ENUMERATION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_EXPR_ENUMERATION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Case Expr Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_EXPR_ENUMERATION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CaseEnumerationImpl <em>Case Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CaseEnumerationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCaseEnumeration()
	 * @generated
	 */
	int CASE_ENUMERATION = 14;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_ENUMERATION__COMMENT_PRE = CASE_EXPR_ENUMERATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_ENUMERATION__COMMENT_POST = CASE_EXPR_ENUMERATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_ENUMERATION__LIST_EXPR_SIGNAL = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Case Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_ENUMERATION_FEATURE_COUNT = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CaseIntervalImpl <em>Case Interval</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CaseIntervalImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCaseInterval()
	 * @generated
	 */
	int CASE_INTERVAL = 16;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL__COMMENT_PRE = CASE_EXPR_ENUMERATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL__COMMENT_POST = CASE_EXPR_ENUMERATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL__LOWER_BOUND = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL__UPPER_BOUND = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Intervals Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL__INTERVALS_KIND = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Case Interval</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_INTERVAL_FEATURE_COUNT = CASE_EXPR_ENUMERATION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CaseProcessImpl <em>Case Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CaseProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCaseProcess()
	 * @generated
	 */
	int CASE_PROCESS = 17;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS__IDENTIFIER = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Case Branch</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS__LIST_CASE_BRANCH = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Else Case</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS__ELSE_CASE = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Case Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_PROCESS_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CaseBranchImpl <em>Case Branch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CaseBranchImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCaseBranch()
	 * @generated
	 */
	int CASE_BRANCH = 18;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_BRANCH__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_BRANCH__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Enumeration Values</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_BRANCH__ENUMERATION_VALUES = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_BRANCH__EXPR_PROCESS = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Case Branch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CASE_BRANCH_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.TernaryOperators <em>Ternary Operators</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.TernaryOperators
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTernaryOperators()
	 * @generated
	 */
	int TERNARY_OPERATORS = 140;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS__EXPR_SIGNAL1 = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS__EXPR_SIGNAL2 = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS__EXPR_SIGNAL3 = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Ternary Operators</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TERNARY_OPERATORS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CellImpl <em>Cell</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CellImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCell()
	 * @generated
	 */
	int CELL = 19;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__COMMENT_PRE = TERNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__COMMENT_POST = TERNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__EXPR_SIGNAL1 = TERNARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__EXPR_SIGNAL2 = TERNARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL__EXPR_SIGNAL3 = TERNARY_OPERATORS__EXPR_SIGNAL3;

	/**
	 * The number of structural features of the '<em>Cell</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CELL_FEATURE_COUNT = TERNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.UnaryOperators <em>Unary Operators</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.UnaryOperators
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getUnaryOperators()
	 * @generated
	 */
	int UNARY_OPERATORS = 152;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OPERATORS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OPERATORS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OPERATORS__EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Operators</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_OPERATORS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockImpl <em>Clock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClock()
	 * @generated
	 */
	int CLOCK = 20;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockDifferenceImpl <em>Clock Difference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockDifferenceImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockDifference()
	 * @generated
	 */
	int CLOCK_DIFFERENCE = 21;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_DIFFERENCE__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_DIFFERENCE__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_DIFFERENCE__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_DIFFERENCE__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Clock Difference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_DIFFERENCE_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockEqualityImpl <em>Clock Equality</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockEqualityImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockEquality()
	 * @generated
	 */
	int CLOCK_EQUALITY = 22;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EQUALITY__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EQUALITY__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EQUALITY__EXPR_SIGNAL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Clock Equality</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EQUALITY_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockExclusiveRelationImpl <em>Clock Exclusive Relation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockExclusiveRelationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockExclusiveRelation()
	 * @generated
	 */
	int CLOCK_EXCLUSIVE_RELATION = 23;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EXCLUSIVE_RELATION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EXCLUSIVE_RELATION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EXCLUSIVE_RELATION__EXPR_SIGNAL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Clock Exclusive Relation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_EXCLUSIVE_RELATION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockInfRelationImpl <em>Clock Inf Relation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockInfRelationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockInfRelation()
	 * @generated
	 */
	int CLOCK_INF_RELATION = 24;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_INF_RELATION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_INF_RELATION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_INF_RELATION__EXPR_SIGNAL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Clock Inf Relation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_INF_RELATION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockProductImpl <em>Clock Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockProductImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockProduct()
	 * @generated
	 */
	int CLOCK_PRODUCT = 25;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_PRODUCT__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_PRODUCT__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_PRODUCT__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_PRODUCT__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Clock Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_PRODUCT_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockSupRelationImpl <em>Clock Sup Relation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockSupRelationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockSupRelation()
	 * @generated
	 */
	int CLOCK_SUP_RELATION = 26;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_SUP_RELATION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_SUP_RELATION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_SUP_RELATION__EXPR_SIGNAL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Clock Sup Relation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_SUP_RELATION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ClockUnionImpl <em>Clock Union</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ClockUnionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getClockUnion()
	 * @generated
	 */
	int CLOCK_UNION = 27;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_UNION__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_UNION__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_UNION__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_UNION__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Clock Union</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_UNION_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CommentImpl <em>Comment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CommentImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getComment()
	 * @generated
	 */
	int COMMENT = 28;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__ATOM_STRING = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ComplexConstructorImpl <em>Complex Constructor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ComplexConstructorImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getComplexConstructor()
	 * @generated
	 */
	int COMPLEX_CONSTRUCTOR = 29;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_CONSTRUCTOR__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_CONSTRUCTOR__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_CONSTRUCTOR__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_CONSTRUCTOR__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Complex Constructor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPLEX_CONSTRUCTOR_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CompositionImpl <em>Composition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CompositionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getComposition()
	 * @generated
	 */
	int COMPOSITION = 30;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Expr Process</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION__LIST_EXPR_PROCESS = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Composition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConcatenationImpl <em>Concatenation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConcatenationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConcatenation()
	 * @generated
	 */
	int CONCATENATION = 31;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCATENATION__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCATENATION__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCATENATION__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCATENATION__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Concatenation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONCATENATION_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.Dependences <em>Dependences</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.Dependences
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDependences()
	 * @generated
	 */
	int DEPENDENCES = 51;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCES__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCES__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Dependences</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDENCES_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConditionedDependenceImpl <em>Conditioned Dependence</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConditionedDependenceImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConditionedDependence()
	 * @generated
	 */
	int CONDITIONED_DEPENDENCE = 32;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE__COMMENT_PRE = DEPENDENCES__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE__COMMENT_POST = DEPENDENCES__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Signals From</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE__SIGNALS_FROM = DEPENDENCES_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Signals To</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE__SIGNALS_TO = DEPENDENCES_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Condition Expr</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE__CONDITION_EXPR = DEPENDENCES_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Conditioned Dependence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONED_DEPENDENCE_FEATURE_COUNT = DEPENDENCES_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.Constant <em>Constant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.Constant
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstant()
	 * @generated
	 */
	int CONSTANT = 33;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Constant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantCharacterImpl <em>Constant Character</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantCharacterImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantCharacter()
	 * @generated
	 */
	int CONSTANT_CHARACTER = 34;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_CHARACTER__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_CHARACTER__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_CHARACTER__ATOM_STRING = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Character</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_CHARACTER_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ConstantDefinition <em>Constant Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ConstantDefinition
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantDefinition()
	 * @generated
	 */
	int CONSTANT_DEFINITION = 35;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DEFINITION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DEFINITION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Constant Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DEFINITION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantDescriptionImpl <em>Constant Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantDescriptionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantDescription()
	 * @generated
	 */
	int CONSTANT_DESCRIPTION = 36;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION__COMMENT_PRE = CONSTANT_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION__COMMENT_POST = CONSTANT_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION__IDENTIFIER = CONSTANT_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constant Description Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION__CONSTANT_DESCRIPTION_VALUE = CONSTANT_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Constant Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION_FEATURE_COUNT = CONSTANT_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ConstantDescriptionValue <em>Constant Description Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ConstantDescriptionValue
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantDescriptionValue()
	 * @generated
	 */
	int CONSTANT_DESCRIPTION_VALUE = 37;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION_VALUE__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION_VALUE__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Constant Description Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DESCRIPTION_VALUE_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantDoubleRealImpl <em>Constant Double Real</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantDoubleRealImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantDoubleReal()
	 * @generated
	 */
	int CONSTANT_DOUBLE_REAL = 38;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_REAL__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_REAL__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_REAL__ATOM_STRING = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Double Real</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_DOUBLE_REAL_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantEnumImpl <em>Constant Enum</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantEnumImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantEnum()
	 * @generated
	 */
	int CONSTANT_ENUM = 39;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_ENUM__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_ENUM__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Type Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_ENUM__TYPE_IDENTIFIER = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constant Enum Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_ENUM__CONSTANT_ENUM_VALUE = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Constant Enum</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_ENUM_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantIntegerImpl <em>Constant Integer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantIntegerImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantInteger()
	 * @generated
	 */
	int CONSTANT_INTEGER = 40;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_INTEGER__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_INTEGER__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_INTEGER__ATOM_STRING = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Integer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_INTEGER_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantLogicalImpl <em>Constant Logical</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantLogicalImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantLogical()
	 * @generated
	 */
	int CONSTANT_LOGICAL = 41;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LOGICAL__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LOGICAL__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Constant Logical Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LOGICAL__CONSTANT_LOGICAL_KIND = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Logical</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_LOGICAL_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantRealImpl <em>Constant Real</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantRealImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantReal()
	 * @generated
	 */
	int CONSTANT_REAL = 42;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_REAL__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_REAL__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_REAL__ATOM_STRING = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant Real</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_REAL_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.Declaration <em>Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.Declaration
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDeclaration()
	 * @generated
	 */
	int DECLARATION = 48;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLARATION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantsDeclarationImpl <em>Constants Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantsDeclarationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantsDeclaration()
	 * @generated
	 */
	int CONSTANTS_DECLARATION = 43;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION__VISIBILITY = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION__TYPE = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>List Constant Definition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION__LIST_CONSTANT_DEFINITION = DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Constants Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANTS_DECLARATION_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConstantStringImpl <em>Constant String</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConstantStringImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantString()
	 * @generated
	 */
	int CONSTANT_STRING = 44;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_STRING__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_STRING__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_STRING__ATOM_STRING = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constant String</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTANT_STRING_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ConversionImpl <em>Conversion</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ConversionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConversion()
	 * @generated
	 */
	int CONVERSION = 45;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONVERSION__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONVERSION__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Predefined Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONVERSION__PREDEFINED_TYPE = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONVERSION__EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Conversion</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONVERSION_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.CountImpl <em>Count</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.CountImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getCount()
	 * @generated
	 */
	int COUNT = 47;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.DefaultImpl <em>Default</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.DefaultImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDefault()
	 * @generated
	 */
	int DEFAULT = 49;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.DelayImpl <em>Delay</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.DelayImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDelay()
	 * @generated
	 */
	int DELAY = 50;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.DescriptionImpl <em>Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.DescriptionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDescription()
	 * @generated
	 */
	int DESCRIPTION = 53;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.DivImpl <em>Div</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.DivImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getDiv()
	 * @generated
	 */
	int DIV = 54;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.PartialArrayDefinition <em>Partial Array Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.PartialArrayDefinition
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPartialArrayDefinition()
	 * @generated
	 */
	int PARTIAL_ARRAY_DEFINITION = 105;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ElemDefinitionImpl <em>Elem Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ElemDefinitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getElemDefinition()
	 * @generated
	 */
	int ELEM_DEFINITION = 55;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ElemDefinitionEnumerationImpl <em>Elem Definition Enumeration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ElemDefinitionEnumerationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getElemDefinitionEnumeration()
	 * @generated
	 */
	int ELEM_DEFINITION_ENUMERATION = 56;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.EnumerationTypeImpl <em>Enumeration Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.EnumerationTypeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getEnumerationType()
	 * @generated
	 */
	int ENUMERATION_TYPE = 57;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.EqualImpl <em>Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.EqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getEqual()
	 * @generated
	 */
	int EQUAL = 58;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.EqualEqualImpl <em>Equal Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.EqualEqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getEqualEqual()
	 * @generated
	 */
	int EQUAL_EQUAL = 59;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ExprParam <em>Expr Param</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ExprParam
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExprParam()
	 * @generated
	 */
	int EXPR_PARAM = 60;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ProcessBody <em>Process Body</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ProcessBody
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessBody()
	 * @generated
	 */
	int PROCESS_BODY = 113;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ExternalAttributeImpl <em>External Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ExternalAttributeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExternalAttribute()
	 * @generated
	 */
	int EXTERNAL_ATTRIBUTE = 63;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ExternalGraphImpl <em>External Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ExternalGraphImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExternalGraph()
	 * @generated
	 */
	int EXTERNAL_GRAPH = 64;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ExternalReferencesImpl <em>External References</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ExternalReferencesImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getExternalReferences()
	 * @generated
	 */
	int EXTERNAL_REFERENCES = 65;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.FieldAccessImpl <em>Field Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.FieldAccessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getFieldAccess()
	 * @generated
	 */
	int FIELD_ACCESS = 66;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.TypesOrSignalsDeclaration <em>Types Or Signals Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.TypesOrSignalsDeclaration
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypesOrSignalsDeclaration()
	 * @generated
	 */
	int TYPES_OR_SIGNALS_DECLARATION = 149;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.FormalProcessImpl <em>Formal Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.FormalProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getFormalProcess()
	 * @generated
	 */
	int FORMAL_PROCESS = 67;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.FromImpl <em>From</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.FromImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getFrom()
	 * @generated
	 */
	int FROM = 68;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.GraphSpecificationImpl <em>Graph Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.GraphSpecificationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getGraphSpecification()
	 * @generated
	 */
	int GRAPH_SPECIFICATION = 69;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.GreaterImpl <em>Greater</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.GreaterImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getGreater()
	 * @generated
	 */
	int GREATER = 70;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.GreaterOrEqualImpl <em>Greater Or Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.GreaterOrEqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getGreaterOrEqual()
	 * @generated
	 */
	int GREATER_OR_EQUAL = 71;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IdentifierImpl <em>Identifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IdentifierImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIdentifier()
	 * @generated
	 */
	int IDENTIFIER = 72;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IdentityEquationImpl <em>Identity Equation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IdentityEquationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIdentityEquation()
	 * @generated
	 */
	int IDENTITY_EQUATION = 73;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IfThenElseImpl <em>If Then Else</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IfThenElseImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIfThenElse()
	 * @generated
	 */
	int IF_THEN_ELSE = 74;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IndexImpl <em>Index</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IndexImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIndex()
	 * @generated
	 */
	int INDEX = 75;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.InterfaceDefinition <em>Interface Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.InterfaceDefinition
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getInterfaceDefinition()
	 * @generated
	 */
	int INTERFACE_DEFINITION = 76;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IOProfileImpl <em>IO Profile</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IOProfileImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIOProfile()
	 * @generated
	 */
	int IO_PROFILE = 77;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IterationImpl <em>Iteration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IterationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIteration()
	 * @generated
	 */
	int ITERATION = 78;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.IterationProcessImpl <em>Iteration Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.IterationProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIterationProcess()
	 * @generated
	 */
	int ITERATION_PROCESS = 80;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.LabelledProcessImpl <em>Labelled Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.LabelledProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getLabelledProcess()
	 * @generated
	 */
	int LABELLED_PROCESS = 82;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.LabelsImpl <em>Labels</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.LabelsImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getLabels()
	 * @generated
	 */
	int LABELS = 83;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.LessImpl <em>Less</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.LessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getLess()
	 * @generated
	 */
	int LESS = 84;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.LessLessEqualImpl <em>Less Less Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.LessLessEqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getLessLessEqual()
	 * @generated
	 */
	int LESS_LESS_EQUAL = 85;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.LessOrEqualImpl <em>Less Or Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.LessOrEqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getLessOrEqual()
	 * @generated
	 */
	int LESS_OR_EQUAL = 86;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ListExprSignalImpl <em>List Expr Signal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ListExprSignalImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getListExprSignal()
	 * @generated
	 */
	int LIST_EXPR_SIGNAL = 87;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ListFlowsImpl <em>List Flows</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ListFlowsImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getListFlows()
	 * @generated
	 */
	int LIST_FLOWS = 88;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.RootModel <em>Root Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.RootModel
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getRootModel()
	 * @generated
	 */
	int ROOT_MODEL = 127;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ListModuleImpl <em>List Module</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ListModuleImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getListModule()
	 * @generated
	 */
	int LIST_MODULE = 89;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.MaskingImpl <em>Masking</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.MaskingImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getMasking()
	 * @generated
	 */
	int MASKING = 90;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.MinusImpl <em>Minus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.MinusImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getMinus()
	 * @generated
	 */
	int MINUS = 91;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ModuleImpl <em>Module</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ModuleImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getModule()
	 * @generated
	 */
	int MODULE = 92;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ModuleDescriptionImpl <em>Module Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ModuleDescriptionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getModuleDescription()
	 * @generated
	 */
	int MODULE_DESCRIPTION = 93;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ModulesImportImpl <em>Modules Import</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ModulesImportImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getModulesImport()
	 * @generated
	 */
	int MODULES_IMPORT = 94;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ModuloImpl <em>Modulo</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ModuloImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getModulo()
	 * @generated
	 */
	int MODULO = 95;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.NotImpl <em>Not</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.NotImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getNot()
	 * @generated
	 */
	int NOT = 96;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.NotEqualImpl <em>Not Equal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.NotEqualImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getNotEqual()
	 * @generated
	 */
	int NOT_EQUAL = 97;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.NullaryOperators <em>Nullary Operators</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.NullaryOperators
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getNullaryOperators()
	 * @generated
	 */
	int NULLARY_OPERATORS = 98;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.NullClockImpl <em>Null Clock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.NullClockImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getNullClock()
	 * @generated
	 */
	int NULL_CLOCK = 99;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.NullProcImpl <em>Null Proc</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.NullProcImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getNullProc()
	 * @generated
	 */
	int NULL_PROC = 100;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.OperatorIdentifier <em>Operator Identifier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.OperatorIdentifier
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getOperatorIdentifier()
	 * @generated
	 */
	int OPERATOR_IDENTIFIER = 102;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.OperatorImpl <em>Operator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.OperatorImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getOperator()
	 * @generated
	 */
	int OPERATOR = 101;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.OperatorModelImpl <em>Operator Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.OperatorModelImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getOperatorModel()
	 * @generated
	 */
	int OPERATOR_MODEL = 103;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.OrImpl <em>Or</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.OrImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getOr()
	 * @generated
	 */
	int OR = 104;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PartialIterationImpl <em>Partial Iteration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PartialIterationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPartialIteration()
	 * @generated
	 */
	int PARTIAL_ITERATION = 106;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PlusImpl <em>Plus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PlusImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPlus()
	 * @generated
	 */
	int PLUS = 107;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PowerImpl <em>Power</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PowerImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPower()
	 * @generated
	 */
	int POWER = 108;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PragmaImpl <em>Pragma</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PragmaImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPragma()
	 * @generated
	 */
	int PRAGMA = 109;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PredefinedTypeImpl <em>Predefined Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PredefinedTypeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPredefinedType()
	 * @generated
	 */
	int PREDEFINED_TYPE = 110;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.PreviousIterationRefImpl <em>Previous Iteration Ref</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.PreviousIterationRefImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getPreviousIterationRef()
	 * @generated
	 */
	int PREVIOUS_ITERATION_REF = 111;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessAttributeImpl <em>Process Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessAttributeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessAttribute()
	 * @generated
	 */
	int PROCESS_ATTRIBUTE = 112;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessCallImpl <em>Process Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessCallImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessCall()
	 * @generated
	 */
	int PROCESS_CALL = 114;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ProcessDeclaration <em>Process Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ProcessDeclaration
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessDeclaration()
	 * @generated
	 */
	int PROCESS_DECLARATION = 116;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ProcessInstance <em>Process Instance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ProcessInstance
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessInstance()
	 * @generated
	 */
	int PROCESS_INSTANCE = 118;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessExpansionImpl <em>Process Expansion</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessExpansionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessExpansion()
	 * @generated
	 */
	int PROCESS_EXPANSION = 117;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessModelImpl <em>Process Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessModelImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessModel()
	 * @generated
	 */
	int PROCESS_MODEL = 119;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessModelInterfaceImpl <em>Process Model Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessModelInterfaceImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessModelInterface()
	 * @generated
	 */
	int PROCESS_MODEL_INTERFACE = 120;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.TypeDefinition <em>Type Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.TypeDefinition
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypeDefinition()
	 * @generated
	 */
	int TYPE_DEFINITION = 144;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProcessTypeImpl <em>Process Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProcessTypeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessType()
	 * @generated
	 */
	int PROCESS_TYPE = 121;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ProductImpl <em>Product</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ProductImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProduct()
	 * @generated
	 */
	int PRODUCT = 122;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.RecoverImpl <em>Recover</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.RecoverImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getRecover()
	 * @generated
	 */
	int RECOVER = 123;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ReferenceProcess <em>Reference Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ReferenceProcess
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getReferenceProcess()
	 * @generated
	 */
	int REFERENCE_PROCESS = 124;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.RepetitionImpl <em>Repetition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.RepetitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getRepetition()
	 * @generated
	 */
	int REPETITION = 125;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.RestrictionProcessImpl <em>Restriction Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.RestrictionProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getRestrictionProcess()
	 * @generated
	 */
	int RESTRICTION_PROCESS = 126;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SequentialDefinitionImpl <em>Sequential Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SequentialDefinitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSequentialDefinition()
	 * @generated
	 */
	int SEQUENTIAL_DEFINITION = 128;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SharedVariablesDeclarationImpl <em>Shared Variables Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SharedVariablesDeclarationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSharedVariablesDeclaration()
	 * @generated
	 */
	int SHARED_VARIABLES_DECLARATION = 129;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalNamingImpl <em>Signal Naming</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalNamingImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalNaming()
	 * @generated
	 */
	int SIGNAL_NAMING = 131;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalsImpl <em>Signals</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalsImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignals()
	 * @generated
	 */
	int SIGNALS = 132;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalsDeclarationImpl <em>Signals Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalsDeclarationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalsDeclaration()
	 * @generated
	 */
	int SIGNALS_DECLARATION = 133;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalsDefinitionImpl <em>Signals Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalsDefinitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalsDefinition()
	 * @generated
	 */
	int SIGNALS_DEFINITION = 134;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalsPartialDefaultDefinitionImpl <em>Signals Partial Default Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalsPartialDefaultDefinitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalsPartialDefaultDefinition()
	 * @generated
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION = 135;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.SignalsPartialDefinitionImpl <em>Signals Partial Definition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.SignalsPartialDefinitionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalsPartialDefinition()
	 * @generated
	 */
	int SIGNALS_PARTIAL_DEFINITION = 136;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.StateVariablesDeclarationImpl <em>State Variables Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.StateVariablesDeclarationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getStateVariablesDeclaration()
	 * @generated
	 */
	int STATE_VARIABLES_DECLARATION = 137;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.StateVariableValueImpl <em>State Variable Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.StateVariableValueImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getStateVariableValue()
	 * @generated
	 */
	int STATE_VARIABLE_VALUE = 138;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.StringValueImpl <em>String Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.StringValueImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getStringValue()
	 * @generated
	 */
	int STRING_VALUE = 139;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.TranspositionImpl <em>Transposition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.TranspositionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTransposition()
	 * @generated
	 */
	int TRANSPOSITION = 141;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.TupleTypeImpl <em>Tuple Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.TupleTypeImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTupleType()
	 * @generated
	 */
	int TUPLE_TYPE = 142;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.TypeDescriptionImpl <em>Type Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.TypeDescriptionImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypeDescription()
	 * @generated
	 */
	int TYPE_DESCRIPTION = 145;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.TypeMorphismImpl <em>Type Morphism</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.TypeMorphismImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypeMorphism()
	 * @generated
	 */
	int TYPE_MORPHISM = 147;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.TypesDeclarationImpl <em>Types Declaration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.TypesDeclarationImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypesDeclaration()
	 * @generated
	 */
	int TYPES_DECLARATION = 148;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.UnaryMinusImpl <em>Unary Minus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.UnaryMinusImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getUnaryMinus()
	 * @generated
	 */
	int UNARY_MINUS = 150;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.UnaryPlusImpl <em>Unary Plus</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.UnaryPlusImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getUnaryPlus()
	 * @generated
	 */
	int UNARY_PLUS = 151;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.UnaryWhenImpl <em>Unary When</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.UnaryWhenImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getUnaryWhen()
	 * @generated
	 */
	int UNARY_WHEN = 153;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.UnconditionedDependencesImpl <em>Unconditioned Dependences</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.UnconditionedDependencesImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getUnconditionedDependences()
	 * @generated
	 */
	int UNCONDITIONED_DEPENDENCES = 154;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.VarImpl <em>Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.VarImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getVar()
	 * @generated
	 */
	int VAR = 155;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.WhenImpl <em>When</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.WhenImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getWhen()
	 * @generated
	 */
	int WHEN = 156;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.WindowImpl <em>Window</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.WindowImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getWindow()
	 * @generated
	 */
	int WINDOW = 157;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.XorImpl <em>Xor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.XorImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getXor()
	 * @generated
	 */
	int XOR = 158;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.impl.ControlledProcessImpl <em>Controlled Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.impl.ControlledProcessImpl
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getControlledProcess()
	 * @generated
	 */
	int CONTROLLED_PROCESS = 46;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLLED_PROCESS__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLLED_PROCESS__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLLED_PROCESS__EXPR_SIGNAL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLLED_PROCESS__EXPR_PROCESS = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Controlled Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROLLED_PROCESS_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNT__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNT__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNT__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNT__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Count</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COUNT_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Default</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEFAULT_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__COMMENT_PRE = TERNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__COMMENT_POST = TERNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__EXPR_SIGNAL1 = TERNARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__EXPR_SIGNAL2 = TERNARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY__EXPR_SIGNAL3 = TERNARY_OPERATORS__EXPR_SIGNAL3;

	/**
	 * The number of structural features of the '<em>Delay</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DELAY_FEATURE_COUNT = TERNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIPTION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIPTION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Pragma</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIPTION__LIST_PRAGMA = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Body</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIPTION__BODY = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DESCRIPTION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Div</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DIV_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ARRAY_DEFINITION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ARRAY_DEFINITION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Partial Array Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION__COMMENT_PRE = PARTIAL_ARRAY_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION__COMMENT_POST = PARTIAL_ARRAY_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Dimension</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION__EXPR_DIMENSION = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION__EXPR_SIGNAL = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Elem Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION_FEATURE_COUNT = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION_ENUMERATION__COMMENT_PRE = ITERATIVE_ENUMERATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION_ENUMERATION__COMMENT_POST = ITERATIVE_ENUMERATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION_ENUMERATION__LIST_EXPR_SIGNAL = ITERATIVE_ENUMERATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Elem Definition Enumeration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEM_DEFINITION_ENUMERATION_FEATURE_COUNT = ITERATIVE_ENUMERATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__COMMENT_PRE = DESCRIBED_TYPE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__COMMENT_POST = DESCRIBED_TYPE__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Identifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE__LIST_IDENTIFIER = DESCRIBED_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Enumeration Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_TYPE_FEATURE_COUNT = DESCRIBED_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Equal Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PARAM__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PARAM__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Expr Param</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPR_PARAM_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_BODY__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_BODY__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Process Body</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_BODY_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_ATTRIBUTE__COMMENT_PRE = PROCESS_BODY__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_ATTRIBUTE__COMMENT_POST = PROCESS_BODY__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>String</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_ATTRIBUTE__STRING = PROCESS_BODY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>External Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_ATTRIBUTE_FEATURE_COUNT = PROCESS_BODY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_GRAPH__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_GRAPH__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Process Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_GRAPH__PROCESS_ATTRIBUTES = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Graph Specification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_GRAPH__GRAPH_SPECIFICATION = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>External Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_GRAPH_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_REFERENCES__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_REFERENCES__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Identifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_REFERENCES__LIST_IDENTIFIER = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>External References</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_REFERENCES_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_ACCESS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_ACCESS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_ACCESS__EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_ACCESS__IDENTIFIER = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Field Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_ACCESS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_OR_SIGNALS_DECLARATION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_OR_SIGNALS_DECLARATION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Types Or Signals Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS__COMMENT_PRE = TYPES_OR_SIGNALS_DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS__COMMENT_POST = TYPES_OR_SIGNALS_DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Model Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS__MODEL_KIND = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS__MODEL_TYPE = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Model Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS__MODEL_NAME = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Formal Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORMAL_PROCESS_FEATURE_COUNT = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FROM__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FROM__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FROM__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FROM__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>From</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FROM_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_SPECIFICATION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_SPECIFICATION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_SPECIFICATION__EXPR_PROCESS = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Graph Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_SPECIFICATION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Greater</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Greater Or Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GREATER_OR_EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Atom String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER__ATOM_STRING = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Identifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTIFIER_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTITY_EQUATION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTITY_EQUATION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTITY_EQUATION__EXPR_SIGNAL_LEFT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTITY_EQUATION__EXPR_SIGNAL_RIGHT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Identity Equation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTITY_EQUATION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE__COMMENT_PRE = TERNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE__COMMENT_POST = TERNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE__EXPR_SIGNAL1 = TERNARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE__EXPR_SIGNAL2 = TERNARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE__EXPR_SIGNAL3 = TERNARY_OPERATORS__EXPR_SIGNAL3;

	/**
	 * The number of structural features of the '<em>If Then Else</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IF_THEN_ELSE_FEATURE_COUNT = TERNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX__COMMENT_PRE = TERNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX__COMMENT_POST = TERNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX__EXPR_SIGNAL1 = TERNARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX__EXPR_SIGNAL2 = TERNARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX__EXPR_SIGNAL3 = TERNARY_OPERATORS__EXPR_SIGNAL3;

	/**
	 * The number of structural features of the '<em>Index</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INDEX_FEATURE_COUNT = TERNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_DEFINITION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_DEFINITION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Interface Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_DEFINITION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IO_PROFILE__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IO_PROFILE__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Inputs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IO_PROFILE__INPUTS = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Outputs</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IO_PROFILE__OUTPUTS = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>IO Profile</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IO_PROFILE_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION__COMMENT_PRE = PARTIAL_ARRAY_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION__COMMENT_POST = PARTIAL_ARRAY_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Partial Iteration</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION__PARTIAL_ITERATION = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Elem Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION__ELEM_DEFINITION = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Iteration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_FEATURE_COUNT = PARTIAL_ARRAY_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS__COMMENT_PRE = ITERATION_OF_PROCESSES__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS__COMMENT_POST = ITERATION_OF_PROCESSES__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Iteration Index</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS__ITERATION_INDEX = ITERATION_OF_PROCESSES_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS__EXPR_PROCESS = ITERATION_OF_PROCESSES_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Iteration Init</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS__ITERATION_INIT = ITERATION_OF_PROCESSES_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Iteration Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITERATION_PROCESS_FEATURE_COUNT = ITERATION_OF_PROCESSES_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELLED_PROCESS__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELLED_PROCESS__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELLED_PROCESS__LABEL = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELLED_PROCESS__EXPR_PROCESS = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Labelled Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELLED_PROCESS_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELS__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELS__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Identifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELS__LIST_IDENTIFIER = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Labels</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABELS_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Less</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_LESS_EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_LESS_EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_LESS_EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_LESS_EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Less Less Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_LESS_EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Less Or Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LESS_OR_EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_EXPR_SIGNAL__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_EXPR_SIGNAL__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_EXPR_SIGNAL__EXPR_SIGNAL = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>List Expr Signal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_EXPR_SIGNAL_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_FLOWS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_FLOWS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_FLOWS__EXPR_SIGNAL = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>List Flows</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_FLOWS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT_MODEL__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT_MODEL__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Root Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROOT_MODEL_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_MODULE__COMMENT_PRE = ROOT_MODEL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_MODULE__COMMENT_POST = ROOT_MODEL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Module</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_MODULE__LIST_MODULE = ROOT_MODEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>List Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_MODULE_FEATURE_COUNT = ROOT_MODEL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MASKING__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MASKING__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MASKING__EXPR_PROCESS = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Identifier</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MASKING__LIST_IDENTIFIER = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Masking</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MASKING_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINUS__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINUS__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINUS__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINUS__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Minus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINUS_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Module Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__MODULE_DESCRIPTION = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_DESCRIPTION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_DESCRIPTION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Pragma</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_DESCRIPTION__LIST_PRAGMA = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Declaration</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_DESCRIPTION__LIST_DECLARATION = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Module Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_DESCRIPTION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULES_IMPORT__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULES_IMPORT__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Module</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULES_IMPORT__LIST_MODULE = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Modules Import</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULES_IMPORT_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULO__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULO__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULO__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULO__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Modulo</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULO_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Not</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_EQUAL__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_EQUAL__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_EQUAL__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_EQUAL__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Not Equal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_EQUAL_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULLARY_OPERATORS__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULLARY_OPERATORS__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Nullary Operators</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULLARY_OPERATORS_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_CLOCK__COMMENT_PRE = NULLARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_CLOCK__COMMENT_POST = NULLARY_OPERATORS__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Null Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_CLOCK_FEATURE_COUNT = NULLARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_PROC__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_PROC__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Null Proc</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_PROC_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_IDENTIFIER__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_IDENTIFIER__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Operator Identifier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_IDENTIFIER_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR__COMMENT_PRE = OPERATOR_IDENTIFIER__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR__COMMENT_POST = OPERATOR_IDENTIFIER__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Operator Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR__OPERATOR_KIND = OPERATOR_IDENTIFIER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Operator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_FEATURE_COUNT = OPERATOR_IDENTIFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Operator Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL__OPERATOR_IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Interface Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL__INTERFACE_DEFINITION = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL__DESCRIPTION = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Operator Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATOR_MODEL_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Or</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ITERATION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ITERATION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Index</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ITERATION__INDEX = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ITERATION__BOUNDS = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Partial Iteration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTIAL_ITERATION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLUS__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLUS__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLUS__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLUS__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Plus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PLUS_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Power</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int POWER_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA__IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Pragma Object</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA__LIST_PRAGMA_OBJECT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Pragma Statement</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA__PRAGMA_STATEMENT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Pragma</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRAGMA_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDEFINED_TYPE__COMMENT_PRE = DESCRIBED_TYPE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDEFINED_TYPE__COMMENT_POST = DESCRIBED_TYPE__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDEFINED_TYPE__TYPE = DESCRIBED_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Predefined Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDEFINED_TYPE_FEATURE_COUNT = DESCRIBED_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREVIOUS_ITERATION_REF__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREVIOUS_ITERATION_REF__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREVIOUS_ITERATION_REF__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Previous Iteration Ref</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREVIOUS_ITERATION_REF_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_ATTRIBUTE__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_ATTRIBUTE__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Process Attribute Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_ATTRIBUTE__PROCESS_ATTRIBUTE_KIND = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Process Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_ATTRIBUTE_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL__COMMENT_PRE = PROCESS_CALL_OR_ASSERT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL__COMMENT_POST = PROCESS_CALL_OR_ASSERT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Reference Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL__REFERENCE_PROCESS = PROCESS_CALL_OR_ASSERT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL__LIST_EXPR_SIGNAL = PROCESS_CALL_OR_ASSERT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Process Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_CALL_FEATURE_COUNT = PROCESS_CALL_OR_ASSERT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Process Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_DECLARATION_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INSTANCE__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INSTANCE__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Process Instance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_INSTANCE_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_EXPANSION__COMMENT_PRE = PROCESS_INSTANCE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_EXPANSION__COMMENT_POST = PROCESS_INSTANCE__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_EXPANSION__IDENTIFIER = PROCESS_INSTANCE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Expr Param</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_EXPANSION__LIST_EXPR_PARAM = PROCESS_INSTANCE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Process Expansion</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_EXPANSION_FEATURE_COUNT = PROCESS_INSTANCE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Interface Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__INTERFACE_DEFINITION = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__DESCRIPTION = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Model Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__MODEL_KIND = SIGNAL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Visibility Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL__VISIBILITY_KIND = SIGNAL_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Process Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE__COMMENT_PRE = INTERFACE_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE__COMMENT_POST = INTERFACE_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Formal Parameter</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE__LIST_FORMAL_PARAMETER = INTERFACE_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Io Profile</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE__IO_PROFILE = INTERFACE_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>External Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE__EXTERNAL_GRAPH = INTERFACE_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Process Model Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_MODEL_INTERFACE_FEATURE_COUNT = INTERFACE_DEFINITION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DEFINITION__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DEFINITION__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Type Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DEFINITION_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__COMMENT_PRE = TYPE_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__COMMENT_POST = TYPE_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Model Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__MODEL_KIND = TYPE_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__IDENTIFIER = TYPE_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface Definition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__INTERFACE_DEFINITION = TYPE_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>List Pragma</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE__LIST_PRAGMA = TYPE_DEFINITION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Process Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_TYPE_FEATURE_COUNT = TYPE_DEFINITION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Product</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCT_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECOVER__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECOVER__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECOVER__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECOVER__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Recover</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECOVER_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_PROCESS__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_PROCESS__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The number of structural features of the '<em>Reference Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REFERENCE_PROCESS_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPETITION__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPETITION__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPETITION__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPETITION__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Repetition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REPETITION_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESTRICTION_PROCESS__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESTRICTION_PROCESS__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Process</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESTRICTION_PROCESS__EXPR_PROCESS = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Declarations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESTRICTION_PROCESS__LIST_DECLARATIONS = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Restriction Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESTRICTION_PROCESS_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENTIAL_DEFINITION__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENTIAL_DEFINITION__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENTIAL_DEFINITION__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENTIAL_DEFINITION__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Sequential Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEQUENTIAL_DEFINITION_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHARED_VARIABLES_DECLARATION__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHARED_VARIABLES_DECLARATION__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHARED_VARIABLES_DECLARATION__TYPE = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHARED_VARIABLES_DECLARATION__LIST_SIGNAL = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Shared Variables Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SHARED_VARIABLES_DECLARATION_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_NAMING__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_NAMING__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_NAMING__IDENTIFIER = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Init Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_NAMING__INIT_VALUE = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Signal Naming</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNAL_NAMING_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS__COMMENT_PRE = SIGNAL_ELEMENT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS__COMMENT_POST = SIGNAL_ELEMENT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS__LIST_EXPR_SIGNAL = SIGNAL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Signals</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_FEATURE_COUNT = SIGNAL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DECLARATION__COMMENT_PRE = TYPES_OR_SIGNALS_DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DECLARATION__COMMENT_POST = TYPES_OR_SIGNALS_DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DECLARATION__TYPE = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DECLARATION__LIST_SIGNAL = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Signals Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DECLARATION_FEATURE_COUNT = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DEFINITION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DEFINITION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DEFINITION__EXPR_SIGNAL_LEFT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DEFINITION__EXPR_SIGNAL_RIGHT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Signals Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_DEFINITION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION__EXPR_SIGNAL_LEFT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION__EXPR_SIGNAL_RIGHT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Signals Partial Default Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFAULT_DEFINITION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFINITION__COMMENT_PRE = EXPR_PROCESS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFINITION__COMMENT_POST = EXPR_PROCESS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFINITION__EXPR_SIGNAL_LEFT = EXPR_PROCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expr Signal Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFINITION__EXPR_SIGNAL_RIGHT = EXPR_PROCESS_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Signals Partial Definition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIGNALS_PARTIAL_DEFINITION_FEATURE_COUNT = EXPR_PROCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLES_DECLARATION__COMMENT_PRE = DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLES_DECLARATION__COMMENT_POST = DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLES_DECLARATION__TYPE = DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Signal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLES_DECLARATION__LIST_SIGNAL = DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>State Variables Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLES_DECLARATION_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLE_VALUE__COMMENT_PRE = EXPR_SIGNAL__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLE_VALUE__COMMENT_POST = EXPR_SIGNAL__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLE_VALUE__IDENTIFIER = EXPR_SIGNAL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>State Variable Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATE_VARIABLE_VALUE_FEATURE_COUNT = EXPR_SIGNAL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_VALUE__COMMENT_PRE = CONSTANT__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_VALUE__COMMENT_POST = CONSTANT__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Constant String</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_VALUE__LIST_CONSTANT_STRING = CONSTANT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>String Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_VALUE_FEATURE_COUNT = CONSTANT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSPOSITION__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSPOSITION__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSPOSITION__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Transposition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSPOSITION_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE__COMMENT_PRE = DESCRIBED_TYPE__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE__COMMENT_POST = DESCRIBED_TYPE__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>List Signals Declaration</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE__LIST_SIGNALS_DECLARATION = DESCRIBED_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Graph Specification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE__GRAPH_SPECIFICATION = DESCRIBED_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Type Kind</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE__TYPE_KIND = DESCRIBED_TYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Tuple Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TUPLE_TYPE_FEATURE_COUNT = DESCRIBED_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION__COMMENT_PRE = TYPE_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION__COMMENT_POST = TYPE_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION__IDENTIFIER = TYPE_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type Description Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION__TYPE_DESCRIPTION_VALUE = TYPE_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Init Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION__INIT_VALUE = TYPE_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Type Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_DESCRIPTION_FEATURE_COUNT = TYPE_DEFINITION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_MORPHISM__COMMENT_PRE = TYPE_DEFINITION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_MORPHISM__COMMENT_POST = TYPE_DEFINITION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Described Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_MORPHISM__DESCRIBED_TYPE = TYPE_DEFINITION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type Description Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_MORPHISM__TYPE_DESCRIPTION_VALUE = TYPE_DEFINITION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Type Morphism</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_MORPHISM_FEATURE_COUNT = TYPE_DEFINITION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_DECLARATION__COMMENT_PRE = TYPES_OR_SIGNALS_DECLARATION__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_DECLARATION__COMMENT_POST = TYPES_OR_SIGNALS_DECLARATION__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Visibility</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_DECLARATION__VISIBILITY = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type Definition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_DECLARATION__TYPE_DEFINITION = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Types Declaration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPES_DECLARATION_FEATURE_COUNT = TYPES_OR_SIGNALS_DECLARATION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_MINUS__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_MINUS__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_MINUS__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Unary Minus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_MINUS_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_PLUS__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_PLUS__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_PLUS__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Unary Plus</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_PLUS_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_WHEN__COMMENT_PRE = UNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_WHEN__COMMENT_POST = UNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_WHEN__EXPR_SIGNAL = UNARY_OPERATORS__EXPR_SIGNAL;

	/**
	 * The number of structural features of the '<em>Unary When</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_WHEN_FEATURE_COUNT = UNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCONDITIONED_DEPENDENCES__COMMENT_PRE = DEPENDENCES__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCONDITIONED_DEPENDENCES__COMMENT_POST = DEPENDENCES__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Signals</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCONDITIONED_DEPENDENCES__SIGNALS = DEPENDENCES_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Dependence Elements List</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCONDITIONED_DEPENDENCES__DEPENDENCE_ELEMENTS_LIST = DEPENDENCES_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Unconditioned Dependences</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNCONDITIONED_DEPENDENCES_FEATURE_COUNT = DEPENDENCES_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WHEN__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WHEN__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WHEN__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WHEN__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>When</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WHEN_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW__COMMENT_PRE = TERNARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW__COMMENT_POST = TERNARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW__EXPR_SIGNAL1 = TERNARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW__EXPR_SIGNAL2 = TERNARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The feature id for the '<em><b>Expr Signal3</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW__EXPR_SIGNAL3 = TERNARY_OPERATORS__EXPR_SIGNAL3;

	/**
	 * The number of structural features of the '<em>Window</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WINDOW_FEATURE_COUNT = TERNARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Comment Pre</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__COMMENT_PRE = BINARY_OPERATORS__COMMENT_PRE;

	/**
	 * The feature id for the '<em><b>Comment Post</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__COMMENT_POST = BINARY_OPERATORS__COMMENT_POST;

	/**
	 * The feature id for the '<em><b>Expr Signal1</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__EXPR_SIGNAL1 = BINARY_OPERATORS__EXPR_SIGNAL1;

	/**
	 * The feature id for the '<em><b>Expr Signal2</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR__EXPR_SIGNAL2 = BINARY_OPERATORS__EXPR_SIGNAL2;

	/**
	 * The number of structural features of the '<em>Xor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XOR_FEATURE_COUNT = BINARY_OPERATORS_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ConstantLogicalKind <em>Constant Logical Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ConstantLogicalKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getConstantLogicalKind()
	 * @generated
	 */
	int CONSTANT_LOGICAL_KIND = 159;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.IntervalsKind <em>Intervals Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.IntervalsKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getIntervalsKind()
	 * @generated
	 */
	int INTERVALS_KIND = 160;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ModelKind <em>Model Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ModelKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getModelKind()
	 * @generated
	 */
	int MODEL_KIND = 161;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.OperatorKind <em>Operator Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.OperatorKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getOperatorKind()
	 * @generated
	 */
	int OPERATOR_KIND = 162;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.ProcessAttributeKind <em>Process Attribute Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.ProcessAttributeKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getProcessAttributeKind()
	 * @generated
	 */
	int PROCESS_ATTRIBUTE_KIND = 163;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.SignalIntrinsicType <em>Signal Intrinsic Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.SignalIntrinsicType
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getSignalIntrinsicType()
	 * @generated
	 */
	int SIGNAL_INTRINSIC_TYPE = 164;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.TypeKind <em>Type Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.TypeKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getTypeKind()
	 * @generated
	 */
	int TYPE_KIND = 165;

	/**
	 * The meta object id for the '{@link fr.inria.tea.ssme.VisibilityKind <em>Visibility Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @see fr.inria.tea.ssme.impl.SsmePackageImpl#getVisibilityKind()
	 * @generated
	 */
	int VISIBILITY_KIND = 166;

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.After <em>After</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>After</em>'.
	 * @see fr.inria.tea.ssme.After
	 * @generated
	 */
	EClass getAfter();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.And <em>And</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>And</em>'.
	 * @see fr.inria.tea.ssme.And
	 * @generated
	 */
	EClass getAnd();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayElem <em>Array Elem</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Elem</em>'.
	 * @see fr.inria.tea.ssme.ArrayElem
	 * @generated
	 */
	EClass getArrayElem();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayElem#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ArrayElem#getExprSignal()
	 * @see #getArrayElem()
	 * @generated
	 */
	EReference getArrayElem_ExprSignal();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayElem#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ArrayElem#getListExprSignal()
	 * @see #getArrayElem()
	 * @generated
	 */
	EReference getArrayElem_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayElementsEnumeration <em>Array Elements Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Elements Enumeration</em>'.
	 * @see fr.inria.tea.ssme.ArrayElementsEnumeration
	 * @generated
	 */
	EClass getArrayElementsEnumeration();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ArrayElementsEnumeration#getListPartialArrayDefinition <em>List Partial Array Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Partial Array Definition</em>'.
	 * @see fr.inria.tea.ssme.ArrayElementsEnumeration#getListPartialArrayDefinition()
	 * @see #getArrayElementsEnumeration()
	 * @generated
	 */
	EReference getArrayElementsEnumeration_ListPartialArrayDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayIndex <em>Array Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Index</em>'.
	 * @see fr.inria.tea.ssme.ArrayIndex
	 * @generated
	 */
	EClass getArrayIndex();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayIndex#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.ArrayIndex#getIdentifier()
	 * @see #getArrayIndex()
	 * @generated
	 */
	EReference getArrayIndex_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayIndex#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Upper Bound</em>'.
	 * @see fr.inria.tea.ssme.ArrayIndex#getUpperBound()
	 * @see #getArrayIndex()
	 * @generated
	 */
	EReference getArrayIndex_UpperBound();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayProcess <em>Array Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Process</em>'.
	 * @see fr.inria.tea.ssme.ArrayProcess
	 * @generated
	 */
	EClass getArrayProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayProcess#getArrayIndex <em>Array Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Array Index</em>'.
	 * @see fr.inria.tea.ssme.ArrayProcess#getArrayIndex()
	 * @see #getArrayProcess()
	 * @generated
	 */
	EReference getArrayProcess_ArrayIndex();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayProcess#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.ArrayProcess#getExprProcess()
	 * @see #getArrayProcess()
	 * @generated
	 */
	EReference getArrayProcess_ExprProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayProcess#getIterationInit <em>Iteration Init</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Iteration Init</em>'.
	 * @see fr.inria.tea.ssme.ArrayProcess#getIterationInit()
	 * @see #getArrayProcess()
	 * @generated
	 */
	EReference getArrayProcess_IterationInit();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayProduct <em>Array Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Product</em>'.
	 * @see fr.inria.tea.ssme.ArrayProduct
	 * @generated
	 */
	EClass getArrayProduct();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayRestructuration <em>Array Restructuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Restructuration</em>'.
	 * @see fr.inria.tea.ssme.ArrayRestructuration
	 * @generated
	 */
	EClass getArrayRestructuration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ArrayType <em>Array Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Array Type</em>'.
	 * @see fr.inria.tea.ssme.ArrayType
	 * @generated
	 */
	EClass getArrayType();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayType#getExprDimension <em>Expr Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Dimension</em>'.
	 * @see fr.inria.tea.ssme.ArrayType#getExprDimension()
	 * @see #getArrayType()
	 * @generated
	 */
	EReference getArrayType_ExprDimension();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ArrayType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.ArrayType#getType()
	 * @see #getArrayType()
	 * @generated
	 */
	EReference getArrayType_Type();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.AssertProcess <em>Assert Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assert Process</em>'.
	 * @see fr.inria.tea.ssme.AssertProcess
	 * @generated
	 */
	EClass getAssertProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.AssertProcess#getProcessExpression <em>Process Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Process Expression</em>'.
	 * @see fr.inria.tea.ssme.AssertProcess#getProcessExpression()
	 * @see #getAssertProcess()
	 * @generated
	 */
	EReference getAssertProcess_ProcessExpression();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.AssertSignal <em>Assert Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Assert Signal</em>'.
	 * @see fr.inria.tea.ssme.AssertSignal
	 * @generated
	 */
	EClass getAssertSignal();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.AssertSignal#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.AssertSignal#getExprSignal()
	 * @see #getAssertSignal()
	 * @generated
	 */
	EReference getAssertSignal_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.BinaryOperators <em>Binary Operators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Operators</em>'.
	 * @see fr.inria.tea.ssme.BinaryOperators
	 * @generated
	 */
	EClass getBinaryOperators();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.BinaryOperators#getExprSignal1 <em>Expr Signal1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal1</em>'.
	 * @see fr.inria.tea.ssme.BinaryOperators#getExprSignal1()
	 * @see #getBinaryOperators()
	 * @generated
	 */
	EReference getBinaryOperators_ExprSignal1();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.BinaryOperators#getExprSignal2 <em>Expr Signal2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal2</em>'.
	 * @see fr.inria.tea.ssme.BinaryOperators#getExprSignal2()
	 * @see #getBinaryOperators()
	 * @generated
	 */
	EReference getBinaryOperators_ExprSignal2();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Bounds <em>Bounds</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bounds</em>'.
	 * @see fr.inria.tea.ssme.Bounds
	 * @generated
	 */
	EClass getBounds();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Bounds#getLowerBound <em>Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Lower Bound</em>'.
	 * @see fr.inria.tea.ssme.Bounds#getLowerBound()
	 * @see #getBounds()
	 * @generated
	 */
	EReference getBounds_LowerBound();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Bounds#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Upper Bound</em>'.
	 * @see fr.inria.tea.ssme.Bounds#getUpperBound()
	 * @see #getBounds()
	 * @generated
	 */
	EReference getBounds_UpperBound();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Bounds#getStep <em>Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Step</em>'.
	 * @see fr.inria.tea.ssme.Bounds#getStep()
	 * @see #getBounds()
	 * @generated
	 */
	EReference getBounds_Step();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CartesianProduct <em>Cartesian Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cartesian Product</em>'.
	 * @see fr.inria.tea.ssme.CartesianProduct
	 * @generated
	 */
	EClass getCartesianProduct();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CartesianProduct#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.CartesianProduct#getListExprSignal()
	 * @see #getCartesianProduct()
	 * @generated
	 */
	EReference getCartesianProduct_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CaseEnumeration <em>Case Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Case Enumeration</em>'.
	 * @see fr.inria.tea.ssme.CaseEnumeration
	 * @generated
	 */
	EClass getCaseEnumeration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseEnumeration#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.CaseEnumeration#getListExprSignal()
	 * @see #getCaseEnumeration()
	 * @generated
	 */
	EReference getCaseEnumeration_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CaseExprEnumeration <em>Case Expr Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Case Expr Enumeration</em>'.
	 * @see fr.inria.tea.ssme.CaseExprEnumeration
	 * @generated
	 */
	EClass getCaseExprEnumeration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CaseInterval <em>Case Interval</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Case Interval</em>'.
	 * @see fr.inria.tea.ssme.CaseInterval
	 * @generated
	 */
	EClass getCaseInterval();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseInterval#getLowerBound <em>Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Lower Bound</em>'.
	 * @see fr.inria.tea.ssme.CaseInterval#getLowerBound()
	 * @see #getCaseInterval()
	 * @generated
	 */
	EReference getCaseInterval_LowerBound();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseInterval#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Upper Bound</em>'.
	 * @see fr.inria.tea.ssme.CaseInterval#getUpperBound()
	 * @see #getCaseInterval()
	 * @generated
	 */
	EReference getCaseInterval_UpperBound();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.CaseInterval#getIntervalsKind <em>Intervals Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Intervals Kind</em>'.
	 * @see fr.inria.tea.ssme.CaseInterval#getIntervalsKind()
	 * @see #getCaseInterval()
	 * @generated
	 */
	EAttribute getCaseInterval_IntervalsKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CaseProcess <em>Case Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Case Process</em>'.
	 * @see fr.inria.tea.ssme.CaseProcess
	 * @generated
	 */
	EClass getCaseProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseProcess#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.CaseProcess#getIdentifier()
	 * @see #getCaseProcess()
	 * @generated
	 */
	EReference getCaseProcess_Identifier();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.CaseProcess#getListCaseBranch <em>List Case Branch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Case Branch</em>'.
	 * @see fr.inria.tea.ssme.CaseProcess#getListCaseBranch()
	 * @see #getCaseProcess()
	 * @generated
	 */
	EReference getCaseProcess_ListCaseBranch();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseProcess#getElseCase <em>Else Case</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Else Case</em>'.
	 * @see fr.inria.tea.ssme.CaseProcess#getElseCase()
	 * @see #getCaseProcess()
	 * @generated
	 */
	EReference getCaseProcess_ElseCase();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.CaseBranch <em>Case Branch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Case Branch</em>'.
	 * @see fr.inria.tea.ssme.CaseBranch
	 * @generated
	 */
	EClass getCaseBranch();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseBranch#getEnumerationValues <em>Enumeration Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Enumeration Values</em>'.
	 * @see fr.inria.tea.ssme.CaseBranch#getEnumerationValues()
	 * @see #getCaseBranch()
	 * @generated
	 */
	EReference getCaseBranch_EnumerationValues();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.CaseBranch#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.CaseBranch#getExprProcess()
	 * @see #getCaseBranch()
	 * @generated
	 */
	EReference getCaseBranch_ExprProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Cell <em>Cell</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cell</em>'.
	 * @see fr.inria.tea.ssme.Cell
	 * @generated
	 */
	EClass getCell();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Clock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock</em>'.
	 * @see fr.inria.tea.ssme.Clock
	 * @generated
	 */
	EClass getClock();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockDifference <em>Clock Difference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Difference</em>'.
	 * @see fr.inria.tea.ssme.ClockDifference
	 * @generated
	 */
	EClass getClockDifference();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockEquality <em>Clock Equality</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Equality</em>'.
	 * @see fr.inria.tea.ssme.ClockEquality
	 * @generated
	 */
	EClass getClockEquality();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ClockEquality#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ClockEquality#getExprSignal()
	 * @see #getClockEquality()
	 * @generated
	 */
	EReference getClockEquality_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockExclusiveRelation <em>Clock Exclusive Relation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Exclusive Relation</em>'.
	 * @see fr.inria.tea.ssme.ClockExclusiveRelation
	 * @generated
	 */
	EClass getClockExclusiveRelation();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ClockExclusiveRelation#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ClockExclusiveRelation#getExprSignal()
	 * @see #getClockExclusiveRelation()
	 * @generated
	 */
	EReference getClockExclusiveRelation_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockInfRelation <em>Clock Inf Relation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Inf Relation</em>'.
	 * @see fr.inria.tea.ssme.ClockInfRelation
	 * @generated
	 */
	EClass getClockInfRelation();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ClockInfRelation#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ClockInfRelation#getExprSignal()
	 * @see #getClockInfRelation()
	 * @generated
	 */
	EReference getClockInfRelation_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockProduct <em>Clock Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Product</em>'.
	 * @see fr.inria.tea.ssme.ClockProduct
	 * @generated
	 */
	EClass getClockProduct();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockSupRelation <em>Clock Sup Relation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Sup Relation</em>'.
	 * @see fr.inria.tea.ssme.ClockSupRelation
	 * @generated
	 */
	EClass getClockSupRelation();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ClockSupRelation#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ClockSupRelation#getExprSignal()
	 * @see #getClockSupRelation()
	 * @generated
	 */
	EReference getClockSupRelation_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ClockUnion <em>Clock Union</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock Union</em>'.
	 * @see fr.inria.tea.ssme.ClockUnion
	 * @generated
	 */
	EClass getClockUnion();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comment</em>'.
	 * @see fr.inria.tea.ssme.Comment
	 * @generated
	 */
	EClass getComment();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.Comment#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.Comment#getAtomString()
	 * @see #getComment()
	 * @generated
	 */
	EAttribute getComment_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ComplexConstructor <em>Complex Constructor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Complex Constructor</em>'.
	 * @see fr.inria.tea.ssme.ComplexConstructor
	 * @generated
	 */
	EClass getComplexConstructor();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Composition <em>Composition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composition</em>'.
	 * @see fr.inria.tea.ssme.Composition
	 * @generated
	 */
	EClass getComposition();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Composition#getListExprProcess <em>List Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Expr Process</em>'.
	 * @see fr.inria.tea.ssme.Composition#getListExprProcess()
	 * @see #getComposition()
	 * @generated
	 */
	EReference getComposition_ListExprProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Concatenation <em>Concatenation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Concatenation</em>'.
	 * @see fr.inria.tea.ssme.Concatenation
	 * @generated
	 */
	EClass getConcatenation();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConditionedDependence <em>Conditioned Dependence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conditioned Dependence</em>'.
	 * @see fr.inria.tea.ssme.ConditionedDependence
	 * @generated
	 */
	EClass getConditionedDependence();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConditionedDependence#getSignalsFrom <em>Signals From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Signals From</em>'.
	 * @see fr.inria.tea.ssme.ConditionedDependence#getSignalsFrom()
	 * @see #getConditionedDependence()
	 * @generated
	 */
	EReference getConditionedDependence_SignalsFrom();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConditionedDependence#getSignalsTo <em>Signals To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Signals To</em>'.
	 * @see fr.inria.tea.ssme.ConditionedDependence#getSignalsTo()
	 * @see #getConditionedDependence()
	 * @generated
	 */
	EReference getConditionedDependence_SignalsTo();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConditionedDependence#getConditionExpr <em>Condition Expr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition Expr</em>'.
	 * @see fr.inria.tea.ssme.ConditionedDependence#getConditionExpr()
	 * @see #getConditionedDependence()
	 * @generated
	 */
	EReference getConditionedDependence_ConditionExpr();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Constant <em>Constant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant</em>'.
	 * @see fr.inria.tea.ssme.Constant
	 * @generated
	 */
	EClass getConstant();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantCharacter <em>Constant Character</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Character</em>'.
	 * @see fr.inria.tea.ssme.ConstantCharacter
	 * @generated
	 */
	EClass getConstantCharacter();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantCharacter#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.ConstantCharacter#getAtomString()
	 * @see #getConstantCharacter()
	 * @generated
	 */
	EAttribute getConstantCharacter_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantDefinition <em>Constant Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Definition</em>'.
	 * @see fr.inria.tea.ssme.ConstantDefinition
	 * @generated
	 */
	EClass getConstantDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantDescription <em>Constant Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Description</em>'.
	 * @see fr.inria.tea.ssme.ConstantDescription
	 * @generated
	 */
	EClass getConstantDescription();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConstantDescription#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.ConstantDescription#getIdentifier()
	 * @see #getConstantDescription()
	 * @generated
	 */
	EReference getConstantDescription_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConstantDescription#getConstantDescriptionValue <em>Constant Description Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constant Description Value</em>'.
	 * @see fr.inria.tea.ssme.ConstantDescription#getConstantDescriptionValue()
	 * @see #getConstantDescription()
	 * @generated
	 */
	EReference getConstantDescription_ConstantDescriptionValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantDescriptionValue <em>Constant Description Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Description Value</em>'.
	 * @see fr.inria.tea.ssme.ConstantDescriptionValue
	 * @generated
	 */
	EClass getConstantDescriptionValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantDoubleReal <em>Constant Double Real</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Double Real</em>'.
	 * @see fr.inria.tea.ssme.ConstantDoubleReal
	 * @generated
	 */
	EClass getConstantDoubleReal();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantDoubleReal#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.ConstantDoubleReal#getAtomString()
	 * @see #getConstantDoubleReal()
	 * @generated
	 */
	EAttribute getConstantDoubleReal_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantEnum <em>Constant Enum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Enum</em>'.
	 * @see fr.inria.tea.ssme.ConstantEnum
	 * @generated
	 */
	EClass getConstantEnum();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConstantEnum#getTypeIdentifier <em>Type Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type Identifier</em>'.
	 * @see fr.inria.tea.ssme.ConstantEnum#getTypeIdentifier()
	 * @see #getConstantEnum()
	 * @generated
	 */
	EReference getConstantEnum_TypeIdentifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConstantEnum#getConstantEnumValue <em>Constant Enum Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constant Enum Value</em>'.
	 * @see fr.inria.tea.ssme.ConstantEnum#getConstantEnumValue()
	 * @see #getConstantEnum()
	 * @generated
	 */
	EReference getConstantEnum_ConstantEnumValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantInteger <em>Constant Integer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Integer</em>'.
	 * @see fr.inria.tea.ssme.ConstantInteger
	 * @generated
	 */
	EClass getConstantInteger();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantInteger#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.ConstantInteger#getAtomString()
	 * @see #getConstantInteger()
	 * @generated
	 */
	EAttribute getConstantInteger_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantLogical <em>Constant Logical</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Logical</em>'.
	 * @see fr.inria.tea.ssme.ConstantLogical
	 * @generated
	 */
	EClass getConstantLogical();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantLogical#getConstantLogicalKind <em>Constant Logical Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Constant Logical Kind</em>'.
	 * @see fr.inria.tea.ssme.ConstantLogical#getConstantLogicalKind()
	 * @see #getConstantLogical()
	 * @generated
	 */
	EAttribute getConstantLogical_ConstantLogicalKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantReal <em>Constant Real</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant Real</em>'.
	 * @see fr.inria.tea.ssme.ConstantReal
	 * @generated
	 */
	EClass getConstantReal();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantReal#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.ConstantReal#getAtomString()
	 * @see #getConstantReal()
	 * @generated
	 */
	EAttribute getConstantReal_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantsDeclaration <em>Constants Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constants Declaration</em>'.
	 * @see fr.inria.tea.ssme.ConstantsDeclaration
	 * @generated
	 */
	EClass getConstantsDeclaration();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantsDeclaration#getVisibility <em>Visibility</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Visibility</em>'.
	 * @see fr.inria.tea.ssme.ConstantsDeclaration#getVisibility()
	 * @see #getConstantsDeclaration()
	 * @generated
	 */
	EAttribute getConstantsDeclaration_Visibility();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ConstantsDeclaration#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.ConstantsDeclaration#getType()
	 * @see #getConstantsDeclaration()
	 * @generated
	 */
	EReference getConstantsDeclaration_Type();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ConstantsDeclaration#getListConstantDefinition <em>List Constant Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Constant Definition</em>'.
	 * @see fr.inria.tea.ssme.ConstantsDeclaration#getListConstantDefinition()
	 * @see #getConstantsDeclaration()
	 * @generated
	 */
	EReference getConstantsDeclaration_ListConstantDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ConstantString <em>Constant String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constant String</em>'.
	 * @see fr.inria.tea.ssme.ConstantString
	 * @generated
	 */
	EClass getConstantString();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ConstantString#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.ConstantString#getAtomString()
	 * @see #getConstantString()
	 * @generated
	 */
	EAttribute getConstantString_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Conversion <em>Conversion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conversion</em>'.
	 * @see fr.inria.tea.ssme.Conversion
	 * @generated
	 */
	EClass getConversion();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Conversion#getPredefinedType <em>Predefined Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Predefined Type</em>'.
	 * @see fr.inria.tea.ssme.Conversion#getPredefinedType()
	 * @see #getConversion()
	 * @generated
	 */
	EReference getConversion_PredefinedType();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Conversion#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.Conversion#getExprSignal()
	 * @see #getConversion()
	 * @generated
	 */
	EReference getConversion_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Count <em>Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Count</em>'.
	 * @see fr.inria.tea.ssme.Count
	 * @generated
	 */
	EClass getCount();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Declaration <em>Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Declaration</em>'.
	 * @see fr.inria.tea.ssme.Declaration
	 * @generated
	 */
	EClass getDeclaration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Default <em>Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Default</em>'.
	 * @see fr.inria.tea.ssme.Default
	 * @generated
	 */
	EClass getDefault();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Delay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Delay</em>'.
	 * @see fr.inria.tea.ssme.Delay
	 * @generated
	 */
	EClass getDelay();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Dependences <em>Dependences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependences</em>'.
	 * @see fr.inria.tea.ssme.Dependences
	 * @generated
	 */
	EClass getDependences();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.DescribedType <em>Described Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Described Type</em>'.
	 * @see fr.inria.tea.ssme.DescribedType
	 * @generated
	 */
	EClass getDescribedType();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Description <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Description</em>'.
	 * @see fr.inria.tea.ssme.Description
	 * @generated
	 */
	EClass getDescription();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Description#getListPragma <em>List Pragma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Pragma</em>'.
	 * @see fr.inria.tea.ssme.Description#getListPragma()
	 * @see #getDescription()
	 * @generated
	 */
	EReference getDescription_ListPragma();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Description#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Body</em>'.
	 * @see fr.inria.tea.ssme.Description#getBody()
	 * @see #getDescription()
	 * @generated
	 */
	EReference getDescription_Body();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Div <em>Div</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Div</em>'.
	 * @see fr.inria.tea.ssme.Div
	 * @generated
	 */
	EClass getDiv();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ElemDefinition <em>Elem Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Elem Definition</em>'.
	 * @see fr.inria.tea.ssme.ElemDefinition
	 * @generated
	 */
	EClass getElemDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ElemDefinition#getExprDimension <em>Expr Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Dimension</em>'.
	 * @see fr.inria.tea.ssme.ElemDefinition#getExprDimension()
	 * @see #getElemDefinition()
	 * @generated
	 */
	EReference getElemDefinition_ExprDimension();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ElemDefinition#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ElemDefinition#getExprSignal()
	 * @see #getElemDefinition()
	 * @generated
	 */
	EReference getElemDefinition_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ElemDefinitionEnumeration <em>Elem Definition Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Elem Definition Enumeration</em>'.
	 * @see fr.inria.tea.ssme.ElemDefinitionEnumeration
	 * @generated
	 */
	EClass getElemDefinitionEnumeration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ElemDefinitionEnumeration#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ElemDefinitionEnumeration#getListExprSignal()
	 * @see #getElemDefinitionEnumeration()
	 * @generated
	 */
	EReference getElemDefinitionEnumeration_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.EnumerationType <em>Enumeration Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enumeration Type</em>'.
	 * @see fr.inria.tea.ssme.EnumerationType
	 * @generated
	 */
	EClass getEnumerationType();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.EnumerationType#getListIdentifier <em>List Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Identifier</em>'.
	 * @see fr.inria.tea.ssme.EnumerationType#getListIdentifier()
	 * @see #getEnumerationType()
	 * @generated
	 */
	EReference getEnumerationType_ListIdentifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Equal <em>Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equal</em>'.
	 * @see fr.inria.tea.ssme.Equal
	 * @generated
	 */
	EClass getEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.EqualEqual <em>Equal Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equal Equal</em>'.
	 * @see fr.inria.tea.ssme.EqualEqual
	 * @generated
	 */
	EClass getEqualEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExprParam <em>Expr Param</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expr Param</em>'.
	 * @see fr.inria.tea.ssme.ExprParam
	 * @generated
	 */
	EClass getExprParam();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.ExprProcess
	 * @generated
	 */
	EClass getExprProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ExprSignal
	 * @generated
	 */
	EClass getExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExternalAttribute <em>External Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Attribute</em>'.
	 * @see fr.inria.tea.ssme.ExternalAttribute
	 * @generated
	 */
	EClass getExternalAttribute();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ExternalAttribute#getString <em>String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>String</em>'.
	 * @see fr.inria.tea.ssme.ExternalAttribute#getString()
	 * @see #getExternalAttribute()
	 * @generated
	 */
	EReference getExternalAttribute_String();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExternalGraph <em>External Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Graph</em>'.
	 * @see fr.inria.tea.ssme.ExternalGraph
	 * @generated
	 */
	EClass getExternalGraph();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ExternalGraph#getProcessAttributes <em>Process Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Process Attributes</em>'.
	 * @see fr.inria.tea.ssme.ExternalGraph#getProcessAttributes()
	 * @see #getExternalGraph()
	 * @generated
	 */
	EReference getExternalGraph_ProcessAttributes();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ExternalGraph#getGraphSpecification <em>Graph Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Graph Specification</em>'.
	 * @see fr.inria.tea.ssme.ExternalGraph#getGraphSpecification()
	 * @see #getExternalGraph()
	 * @generated
	 */
	EReference getExternalGraph_GraphSpecification();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ExternalReferences <em>External References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External References</em>'.
	 * @see fr.inria.tea.ssme.ExternalReferences
	 * @generated
	 */
	EClass getExternalReferences();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ExternalReferences#getListIdentifier <em>List Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Identifier</em>'.
	 * @see fr.inria.tea.ssme.ExternalReferences#getListIdentifier()
	 * @see #getExternalReferences()
	 * @generated
	 */
	EReference getExternalReferences_ListIdentifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.FieldAccess <em>Field Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Field Access</em>'.
	 * @see fr.inria.tea.ssme.FieldAccess
	 * @generated
	 */
	EClass getFieldAccess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.FieldAccess#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.FieldAccess#getExprSignal()
	 * @see #getFieldAccess()
	 * @generated
	 */
	EReference getFieldAccess_ExprSignal();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.FieldAccess#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.FieldAccess#getIdentifier()
	 * @see #getFieldAccess()
	 * @generated
	 */
	EReference getFieldAccess_Identifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.FormalProcess <em>Formal Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Formal Process</em>'.
	 * @see fr.inria.tea.ssme.FormalProcess
	 * @generated
	 */
	EClass getFormalProcess();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.FormalProcess#getModelKind <em>Model Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Model Kind</em>'.
	 * @see fr.inria.tea.ssme.FormalProcess#getModelKind()
	 * @see #getFormalProcess()
	 * @generated
	 */
	EAttribute getFormalProcess_ModelKind();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.FormalProcess#getModelType <em>Model Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Model Type</em>'.
	 * @see fr.inria.tea.ssme.FormalProcess#getModelType()
	 * @see #getFormalProcess()
	 * @generated
	 */
	EReference getFormalProcess_ModelType();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.FormalProcess#getModelName <em>Model Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Model Name</em>'.
	 * @see fr.inria.tea.ssme.FormalProcess#getModelName()
	 * @see #getFormalProcess()
	 * @generated
	 */
	EReference getFormalProcess_ModelName();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.From <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>From</em>'.
	 * @see fr.inria.tea.ssme.From
	 * @generated
	 */
	EClass getFrom();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.GraphSpecification <em>Graph Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Graph Specification</em>'.
	 * @see fr.inria.tea.ssme.GraphSpecification
	 * @generated
	 */
	EClass getGraphSpecification();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.GraphSpecification#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.GraphSpecification#getExprProcess()
	 * @see #getGraphSpecification()
	 * @generated
	 */
	EReference getGraphSpecification_ExprProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Greater <em>Greater</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Greater</em>'.
	 * @see fr.inria.tea.ssme.Greater
	 * @generated
	 */
	EClass getGreater();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.GreaterOrEqual <em>Greater Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Greater Or Equal</em>'.
	 * @see fr.inria.tea.ssme.GreaterOrEqual
	 * @generated
	 */
	EClass getGreaterOrEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Identifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.Identifier
	 * @generated
	 */
	EClass getIdentifier();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.Identifier#getAtomString <em>Atom String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Atom String</em>'.
	 * @see fr.inria.tea.ssme.Identifier#getAtomString()
	 * @see #getIdentifier()
	 * @generated
	 */
	EAttribute getIdentifier_AtomString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IdentityEquation <em>Identity Equation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identity Equation</em>'.
	 * @see fr.inria.tea.ssme.IdentityEquation
	 * @generated
	 */
	EClass getIdentityEquation();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.IdentityEquation#getExprSignalLeft <em>Expr Signal Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Left</em>'.
	 * @see fr.inria.tea.ssme.IdentityEquation#getExprSignalLeft()
	 * @see #getIdentityEquation()
	 * @generated
	 */
	EReference getIdentityEquation_ExprSignalLeft();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.IdentityEquation#getExprSignalRight <em>Expr Signal Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Right</em>'.
	 * @see fr.inria.tea.ssme.IdentityEquation#getExprSignalRight()
	 * @see #getIdentityEquation()
	 * @generated
	 */
	EReference getIdentityEquation_ExprSignalRight();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IfThenElse <em>If Then Else</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>If Then Else</em>'.
	 * @see fr.inria.tea.ssme.IfThenElse
	 * @generated
	 */
	EClass getIfThenElse();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Index <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Index</em>'.
	 * @see fr.inria.tea.ssme.Index
	 * @generated
	 */
	EClass getIndex();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.InterfaceDefinition <em>Interface Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Definition</em>'.
	 * @see fr.inria.tea.ssme.InterfaceDefinition
	 * @generated
	 */
	EClass getInterfaceDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IOProfile <em>IO Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IO Profile</em>'.
	 * @see fr.inria.tea.ssme.IOProfile
	 * @generated
	 */
	EClass getIOProfile();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.IOProfile#getInputs <em>Inputs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Inputs</em>'.
	 * @see fr.inria.tea.ssme.IOProfile#getInputs()
	 * @see #getIOProfile()
	 * @generated
	 */
	EReference getIOProfile_Inputs();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.IOProfile#getOutputs <em>Outputs</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Outputs</em>'.
	 * @see fr.inria.tea.ssme.IOProfile#getOutputs()
	 * @see #getIOProfile()
	 * @generated
	 */
	EReference getIOProfile_Outputs();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Iteration <em>Iteration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Iteration</em>'.
	 * @see fr.inria.tea.ssme.Iteration
	 * @generated
	 */
	EClass getIteration();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Iteration#getPartialIteration <em>Partial Iteration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Partial Iteration</em>'.
	 * @see fr.inria.tea.ssme.Iteration#getPartialIteration()
	 * @see #getIteration()
	 * @generated
	 */
	EReference getIteration_PartialIteration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Iteration#getElemDefinition <em>Elem Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Elem Definition</em>'.
	 * @see fr.inria.tea.ssme.Iteration#getElemDefinition()
	 * @see #getIteration()
	 * @generated
	 */
	EReference getIteration_ElemDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IterationOfProcesses <em>Iteration Of Processes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Iteration Of Processes</em>'.
	 * @see fr.inria.tea.ssme.IterationOfProcesses
	 * @generated
	 */
	EClass getIterationOfProcesses();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IterationProcess <em>Iteration Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Iteration Process</em>'.
	 * @see fr.inria.tea.ssme.IterationProcess
	 * @generated
	 */
	EClass getIterationProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.IterationProcess#getIterationIndex <em>Iteration Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Iteration Index</em>'.
	 * @see fr.inria.tea.ssme.IterationProcess#getIterationIndex()
	 * @see #getIterationProcess()
	 * @generated
	 */
	EReference getIterationProcess_IterationIndex();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.IterationProcess#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.IterationProcess#getExprProcess()
	 * @see #getIterationProcess()
	 * @generated
	 */
	EReference getIterationProcess_ExprProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.IterationProcess#getIterationInit <em>Iteration Init</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Iteration Init</em>'.
	 * @see fr.inria.tea.ssme.IterationProcess#getIterationInit()
	 * @see #getIterationProcess()
	 * @generated
	 */
	EReference getIterationProcess_IterationInit();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.IterativeEnumeration <em>Iterative Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Iterative Enumeration</em>'.
	 * @see fr.inria.tea.ssme.IterativeEnumeration
	 * @generated
	 */
	EClass getIterativeEnumeration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.LabelledProcess <em>Labelled Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Labelled Process</em>'.
	 * @see fr.inria.tea.ssme.LabelledProcess
	 * @generated
	 */
	EClass getLabelledProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.LabelledProcess#getLabel <em>Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Label</em>'.
	 * @see fr.inria.tea.ssme.LabelledProcess#getLabel()
	 * @see #getLabelledProcess()
	 * @generated
	 */
	EReference getLabelledProcess_Label();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.LabelledProcess#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.LabelledProcess#getExprProcess()
	 * @see #getLabelledProcess()
	 * @generated
	 */
	EReference getLabelledProcess_ExprProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Labels <em>Labels</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Labels</em>'.
	 * @see fr.inria.tea.ssme.Labels
	 * @generated
	 */
	EClass getLabels();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Labels#getListIdentifier <em>List Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Identifier</em>'.
	 * @see fr.inria.tea.ssme.Labels#getListIdentifier()
	 * @see #getLabels()
	 * @generated
	 */
	EReference getLabels_ListIdentifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Less <em>Less</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Less</em>'.
	 * @see fr.inria.tea.ssme.Less
	 * @generated
	 */
	EClass getLess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.LessLessEqual <em>Less Less Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Less Less Equal</em>'.
	 * @see fr.inria.tea.ssme.LessLessEqual
	 * @generated
	 */
	EClass getLessLessEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.LessOrEqual <em>Less Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Less Or Equal</em>'.
	 * @see fr.inria.tea.ssme.LessOrEqual
	 * @generated
	 */
	EClass getLessOrEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ListExprSignal
	 * @generated
	 */
	EClass getListExprSignal();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ListExprSignal#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ListExprSignal#getExprSignal()
	 * @see #getListExprSignal()
	 * @generated
	 */
	EReference getListExprSignal_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ListFlows <em>List Flows</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Flows</em>'.
	 * @see fr.inria.tea.ssme.ListFlows
	 * @generated
	 */
	EClass getListFlows();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ListFlows#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ListFlows#getExprSignal()
	 * @see #getListFlows()
	 * @generated
	 */
	EReference getListFlows_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ListModule <em>List Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List Module</em>'.
	 * @see fr.inria.tea.ssme.ListModule
	 * @generated
	 */
	EClass getListModule();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ListModule#getListModule <em>List Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Module</em>'.
	 * @see fr.inria.tea.ssme.ListModule#getListModule()
	 * @see #getListModule()
	 * @generated
	 */
	EReference getListModule_ListModule();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Masking <em>Masking</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Masking</em>'.
	 * @see fr.inria.tea.ssme.Masking
	 * @generated
	 */
	EClass getMasking();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Masking#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.Masking#getExprProcess()
	 * @see #getMasking()
	 * @generated
	 */
	EReference getMasking_ExprProcess();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Masking#getListIdentifier <em>List Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Identifier</em>'.
	 * @see fr.inria.tea.ssme.Masking#getListIdentifier()
	 * @see #getMasking()
	 * @generated
	 */
	EReference getMasking_ListIdentifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Minus <em>Minus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Minus</em>'.
	 * @see fr.inria.tea.ssme.Minus
	 * @generated
	 */
	EClass getMinus();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Module <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Module</em>'.
	 * @see fr.inria.tea.ssme.Module
	 * @generated
	 */
	EClass getModule();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Module#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.Module#getIdentifier()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Module#getModuleDescription <em>Module Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Module Description</em>'.
	 * @see fr.inria.tea.ssme.Module#getModuleDescription()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_ModuleDescription();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ModuleDescription <em>Module Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Module Description</em>'.
	 * @see fr.inria.tea.ssme.ModuleDescription
	 * @generated
	 */
	EClass getModuleDescription();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ModuleDescription#getListPragma <em>List Pragma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Pragma</em>'.
	 * @see fr.inria.tea.ssme.ModuleDescription#getListPragma()
	 * @see #getModuleDescription()
	 * @generated
	 */
	EReference getModuleDescription_ListPragma();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ModuleDescription#getListDeclaration <em>List Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Declaration</em>'.
	 * @see fr.inria.tea.ssme.ModuleDescription#getListDeclaration()
	 * @see #getModuleDescription()
	 * @generated
	 */
	EReference getModuleDescription_ListDeclaration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ModulesImport <em>Modules Import</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Modules Import</em>'.
	 * @see fr.inria.tea.ssme.ModulesImport
	 * @generated
	 */
	EClass getModulesImport();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ModulesImport#getListModule <em>List Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Module</em>'.
	 * @see fr.inria.tea.ssme.ModulesImport#getListModule()
	 * @see #getModulesImport()
	 * @generated
	 */
	EReference getModulesImport_ListModule();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Modulo <em>Modulo</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Modulo</em>'.
	 * @see fr.inria.tea.ssme.Modulo
	 * @generated
	 */
	EClass getModulo();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Not <em>Not</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Not</em>'.
	 * @see fr.inria.tea.ssme.Not
	 * @generated
	 */
	EClass getNot();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.NotEqual <em>Not Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Not Equal</em>'.
	 * @see fr.inria.tea.ssme.NotEqual
	 * @generated
	 */
	EClass getNotEqual();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.NullaryOperators <em>Nullary Operators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nullary Operators</em>'.
	 * @see fr.inria.tea.ssme.NullaryOperators
	 * @generated
	 */
	EClass getNullaryOperators();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.NullClock <em>Null Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Null Clock</em>'.
	 * @see fr.inria.tea.ssme.NullClock
	 * @generated
	 */
	EClass getNullClock();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.NullProc <em>Null Proc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Null Proc</em>'.
	 * @see fr.inria.tea.ssme.NullProc
	 * @generated
	 */
	EClass getNullProc();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Operator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operator</em>'.
	 * @see fr.inria.tea.ssme.Operator
	 * @generated
	 */
	EClass getOperator();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.Operator#getOperatorKind <em>Operator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operator Kind</em>'.
	 * @see fr.inria.tea.ssme.Operator#getOperatorKind()
	 * @see #getOperator()
	 * @generated
	 */
	EAttribute getOperator_OperatorKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.OperatorIdentifier <em>Operator Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operator Identifier</em>'.
	 * @see fr.inria.tea.ssme.OperatorIdentifier
	 * @generated
	 */
	EClass getOperatorIdentifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.OperatorModel <em>Operator Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operator Model</em>'.
	 * @see fr.inria.tea.ssme.OperatorModel
	 * @generated
	 */
	EClass getOperatorModel();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.OperatorModel#getOperatorIdentifier <em>Operator Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Operator Identifier</em>'.
	 * @see fr.inria.tea.ssme.OperatorModel#getOperatorIdentifier()
	 * @see #getOperatorModel()
	 * @generated
	 */
	EReference getOperatorModel_OperatorIdentifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.OperatorModel#getInterfaceDefinition <em>Interface Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Definition</em>'.
	 * @see fr.inria.tea.ssme.OperatorModel#getInterfaceDefinition()
	 * @see #getOperatorModel()
	 * @generated
	 */
	EReference getOperatorModel_InterfaceDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.OperatorModel#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Description</em>'.
	 * @see fr.inria.tea.ssme.OperatorModel#getDescription()
	 * @see #getOperatorModel()
	 * @generated
	 */
	EReference getOperatorModel_Description();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Or <em>Or</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or</em>'.
	 * @see fr.inria.tea.ssme.Or
	 * @generated
	 */
	EClass getOr();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.PartialArrayDefinition <em>Partial Array Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Partial Array Definition</em>'.
	 * @see fr.inria.tea.ssme.PartialArrayDefinition
	 * @generated
	 */
	EClass getPartialArrayDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.PartialIteration <em>Partial Iteration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Partial Iteration</em>'.
	 * @see fr.inria.tea.ssme.PartialIteration
	 * @generated
	 */
	EClass getPartialIteration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.PartialIteration#getIndex <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Index</em>'.
	 * @see fr.inria.tea.ssme.PartialIteration#getIndex()
	 * @see #getPartialIteration()
	 * @generated
	 */
	EReference getPartialIteration_Index();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.PartialIteration#getBounds <em>Bounds</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Bounds</em>'.
	 * @see fr.inria.tea.ssme.PartialIteration#getBounds()
	 * @see #getPartialIteration()
	 * @generated
	 */
	EReference getPartialIteration_Bounds();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Plus <em>Plus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Plus</em>'.
	 * @see fr.inria.tea.ssme.Plus
	 * @generated
	 */
	EClass getPlus();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Power <em>Power</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Power</em>'.
	 * @see fr.inria.tea.ssme.Power
	 * @generated
	 */
	EClass getPower();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Pragma <em>Pragma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pragma</em>'.
	 * @see fr.inria.tea.ssme.Pragma
	 * @generated
	 */
	EClass getPragma();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Pragma#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.Pragma#getIdentifier()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_Identifier();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.Pragma#getListPragmaObject <em>List Pragma Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Pragma Object</em>'.
	 * @see fr.inria.tea.ssme.Pragma#getListPragmaObject()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_ListPragmaObject();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Pragma#getPragmaStatement <em>Pragma Statement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pragma Statement</em>'.
	 * @see fr.inria.tea.ssme.Pragma#getPragmaStatement()
	 * @see #getPragma()
	 * @generated
	 */
	EReference getPragma_PragmaStatement();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.PredefinedType <em>Predefined Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Predefined Type</em>'.
	 * @see fr.inria.tea.ssme.PredefinedType
	 * @generated
	 */
	EClass getPredefinedType();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.PredefinedType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.PredefinedType#getType()
	 * @see #getPredefinedType()
	 * @generated
	 */
	EAttribute getPredefinedType_Type();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.PreviousIterationRef <em>Previous Iteration Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Previous Iteration Ref</em>'.
	 * @see fr.inria.tea.ssme.PreviousIterationRef
	 * @generated
	 */
	EClass getPreviousIterationRef();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessAttribute <em>Process Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Attribute</em>'.
	 * @see fr.inria.tea.ssme.ProcessAttribute
	 * @generated
	 */
	EClass getProcessAttribute();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ProcessAttribute#getProcessAttributeKind <em>Process Attribute Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Process Attribute Kind</em>'.
	 * @see fr.inria.tea.ssme.ProcessAttribute#getProcessAttributeKind()
	 * @see #getProcessAttribute()
	 * @generated
	 */
	EAttribute getProcessAttribute_ProcessAttributeKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessBody <em>Process Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Body</em>'.
	 * @see fr.inria.tea.ssme.ProcessBody
	 * @generated
	 */
	EClass getProcessBody();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessCall <em>Process Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Call</em>'.
	 * @see fr.inria.tea.ssme.ProcessCall
	 * @generated
	 */
	EClass getProcessCall();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessCall#getReferenceProcess <em>Reference Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Reference Process</em>'.
	 * @see fr.inria.tea.ssme.ProcessCall#getReferenceProcess()
	 * @see #getProcessCall()
	 * @generated
	 */
	EReference getProcessCall_ReferenceProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessCall#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ProcessCall#getListExprSignal()
	 * @see #getProcessCall()
	 * @generated
	 */
	EReference getProcessCall_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessCallOrAssert <em>Process Call Or Assert</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Call Or Assert</em>'.
	 * @see fr.inria.tea.ssme.ProcessCallOrAssert
	 * @generated
	 */
	EClass getProcessCallOrAssert();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessDeclaration <em>Process Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Declaration</em>'.
	 * @see fr.inria.tea.ssme.ProcessDeclaration
	 * @generated
	 */
	EClass getProcessDeclaration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessExpansion <em>Process Expansion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Expansion</em>'.
	 * @see fr.inria.tea.ssme.ProcessExpansion
	 * @generated
	 */
	EClass getProcessExpansion();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessExpansion#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.ProcessExpansion#getIdentifier()
	 * @see #getProcessExpansion()
	 * @generated
	 */
	EReference getProcessExpansion_Identifier();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ProcessExpansion#getListExprParam <em>List Expr Param</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Expr Param</em>'.
	 * @see fr.inria.tea.ssme.ProcessExpansion#getListExprParam()
	 * @see #getProcessExpansion()
	 * @generated
	 */
	EReference getProcessExpansion_ListExprParam();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessInstance <em>Process Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Instance</em>'.
	 * @see fr.inria.tea.ssme.ProcessInstance
	 * @generated
	 */
	EClass getProcessInstance();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessModel <em>Process Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Model</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel
	 * @generated
	 */
	EClass getProcessModel();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessModel#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel#getIdentifier()
	 * @see #getProcessModel()
	 * @generated
	 */
	EReference getProcessModel_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessModel#getInterfaceDefinition <em>Interface Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Definition</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel#getInterfaceDefinition()
	 * @see #getProcessModel()
	 * @generated
	 */
	EReference getProcessModel_InterfaceDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessModel#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Description</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel#getDescription()
	 * @see #getProcessModel()
	 * @generated
	 */
	EReference getProcessModel_Description();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ProcessModel#getModelKind <em>Model Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Model Kind</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel#getModelKind()
	 * @see #getProcessModel()
	 * @generated
	 */
	EAttribute getProcessModel_ModelKind();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ProcessModel#getVisibilityKind <em>Visibility Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Visibility Kind</em>'.
	 * @see fr.inria.tea.ssme.ProcessModel#getVisibilityKind()
	 * @see #getProcessModel()
	 * @generated
	 */
	EAttribute getProcessModel_VisibilityKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessModelInterface <em>Process Model Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Model Interface</em>'.
	 * @see fr.inria.tea.ssme.ProcessModelInterface
	 * @generated
	 */
	EClass getProcessModelInterface();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ProcessModelInterface#getListFormalParameter <em>List Formal Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Formal Parameter</em>'.
	 * @see fr.inria.tea.ssme.ProcessModelInterface#getListFormalParameter()
	 * @see #getProcessModelInterface()
	 * @generated
	 */
	EReference getProcessModelInterface_ListFormalParameter();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessModelInterface#getIoProfile <em>Io Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Io Profile</em>'.
	 * @see fr.inria.tea.ssme.ProcessModelInterface#getIoProfile()
	 * @see #getProcessModelInterface()
	 * @generated
	 */
	EReference getProcessModelInterface_IoProfile();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessModelInterface#getExternalGraph <em>External Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>External Graph</em>'.
	 * @see fr.inria.tea.ssme.ProcessModelInterface#getExternalGraph()
	 * @see #getProcessModelInterface()
	 * @generated
	 */
	EReference getProcessModelInterface_ExternalGraph();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ProcessType <em>Process Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process Type</em>'.
	 * @see fr.inria.tea.ssme.ProcessType
	 * @generated
	 */
	EClass getProcessType();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.ProcessType#getModelKind <em>Model Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Model Kind</em>'.
	 * @see fr.inria.tea.ssme.ProcessType#getModelKind()
	 * @see #getProcessType()
	 * @generated
	 */
	EAttribute getProcessType_ModelKind();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessType#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.ProcessType#getIdentifier()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ProcessType#getInterfaceDefinition <em>Interface Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Definition</em>'.
	 * @see fr.inria.tea.ssme.ProcessType#getInterfaceDefinition()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_InterfaceDefinition();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.ProcessType#getListPragma <em>List Pragma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Pragma</em>'.
	 * @see fr.inria.tea.ssme.ProcessType#getListPragma()
	 * @see #getProcessType()
	 * @generated
	 */
	EReference getProcessType_ListPragma();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Product <em>Product</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Product</em>'.
	 * @see fr.inria.tea.ssme.Product
	 * @generated
	 */
	EClass getProduct();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Recover <em>Recover</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Recover</em>'.
	 * @see fr.inria.tea.ssme.Recover
	 * @generated
	 */
	EClass getRecover();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ReferenceProcess <em>Reference Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Reference Process</em>'.
	 * @see fr.inria.tea.ssme.ReferenceProcess
	 * @generated
	 */
	EClass getReferenceProcess();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Repetition <em>Repetition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Repetition</em>'.
	 * @see fr.inria.tea.ssme.Repetition
	 * @generated
	 */
	EClass getRepetition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.RestrictionProcess <em>Restriction Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Restriction Process</em>'.
	 * @see fr.inria.tea.ssme.RestrictionProcess
	 * @generated
	 */
	EClass getRestrictionProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.RestrictionProcess#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.RestrictionProcess#getExprProcess()
	 * @see #getRestrictionProcess()
	 * @generated
	 */
	EReference getRestrictionProcess_ExprProcess();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.RestrictionProcess#getListDeclarations <em>List Declarations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Declarations</em>'.
	 * @see fr.inria.tea.ssme.RestrictionProcess#getListDeclarations()
	 * @see #getRestrictionProcess()
	 * @generated
	 */
	EReference getRestrictionProcess_ListDeclarations();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.RootModel <em>Root Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Root Model</em>'.
	 * @see fr.inria.tea.ssme.RootModel
	 * @generated
	 */
	EClass getRootModel();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SequentialDefinition <em>Sequential Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sequential Definition</em>'.
	 * @see fr.inria.tea.ssme.SequentialDefinition
	 * @generated
	 */
	EClass getSequentialDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SharedVariablesDeclaration <em>Shared Variables Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Shared Variables Declaration</em>'.
	 * @see fr.inria.tea.ssme.SharedVariablesDeclaration
	 * @generated
	 */
	EClass getSharedVariablesDeclaration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SharedVariablesDeclaration#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.SharedVariablesDeclaration#getType()
	 * @see #getSharedVariablesDeclaration()
	 * @generated
	 */
	EReference getSharedVariablesDeclaration_Type();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.SharedVariablesDeclaration#getListSignal <em>List Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Signal</em>'.
	 * @see fr.inria.tea.ssme.SharedVariablesDeclaration#getListSignal()
	 * @see #getSharedVariablesDeclaration()
	 * @generated
	 */
	EReference getSharedVariablesDeclaration_ListSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalElement <em>Signal Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signal Element</em>'.
	 * @see fr.inria.tea.ssme.SignalElement
	 * @generated
	 */
	EClass getSignalElement();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.SignalElement#getCommentPre <em>Comment Pre</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Comment Pre</em>'.
	 * @see fr.inria.tea.ssme.SignalElement#getCommentPre()
	 * @see #getSignalElement()
	 * @generated
	 */
	EReference getSignalElement_CommentPre();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.SignalElement#getCommentPost <em>Comment Post</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Comment Post</em>'.
	 * @see fr.inria.tea.ssme.SignalElement#getCommentPost()
	 * @see #getSignalElement()
	 * @generated
	 */
	EReference getSignalElement_CommentPost();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalNaming <em>Signal Naming</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signal Naming</em>'.
	 * @see fr.inria.tea.ssme.SignalNaming
	 * @generated
	 */
	EClass getSignalNaming();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalNaming#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.SignalNaming#getIdentifier()
	 * @see #getSignalNaming()
	 * @generated
	 */
	EReference getSignalNaming_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalNaming#getInitValue <em>Init Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Init Value</em>'.
	 * @see fr.inria.tea.ssme.SignalNaming#getInitValue()
	 * @see #getSignalNaming()
	 * @generated
	 */
	EReference getSignalNaming_InitValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Signals <em>Signals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signals</em>'.
	 * @see fr.inria.tea.ssme.Signals
	 * @generated
	 */
	EClass getSignals();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.Signals#getListExprSignal <em>List Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>List Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.Signals#getListExprSignal()
	 * @see #getSignals()
	 * @generated
	 */
	EReference getSignals_ListExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalsDeclaration <em>Signals Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signals Declaration</em>'.
	 * @see fr.inria.tea.ssme.SignalsDeclaration
	 * @generated
	 */
	EClass getSignalsDeclaration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsDeclaration#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.SignalsDeclaration#getType()
	 * @see #getSignalsDeclaration()
	 * @generated
	 */
	EReference getSignalsDeclaration_Type();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.SignalsDeclaration#getListSignal <em>List Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Signal</em>'.
	 * @see fr.inria.tea.ssme.SignalsDeclaration#getListSignal()
	 * @see #getSignalsDeclaration()
	 * @generated
	 */
	EReference getSignalsDeclaration_ListSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalsDefinition <em>Signals Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signals Definition</em>'.
	 * @see fr.inria.tea.ssme.SignalsDefinition
	 * @generated
	 */
	EClass getSignalsDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsDefinition#getExprSignalLeft <em>Expr Signal Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Left</em>'.
	 * @see fr.inria.tea.ssme.SignalsDefinition#getExprSignalLeft()
	 * @see #getSignalsDefinition()
	 * @generated
	 */
	EReference getSignalsDefinition_ExprSignalLeft();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsDefinition#getExprSignalRight <em>Expr Signal Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Right</em>'.
	 * @see fr.inria.tea.ssme.SignalsDefinition#getExprSignalRight()
	 * @see #getSignalsDefinition()
	 * @generated
	 */
	EReference getSignalsDefinition_ExprSignalRight();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalsPartialDefaultDefinition <em>Signals Partial Default Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signals Partial Default Definition</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefaultDefinition
	 * @generated
	 */
	EClass getSignalsPartialDefaultDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsPartialDefaultDefinition#getExprSignalLeft <em>Expr Signal Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Left</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefaultDefinition#getExprSignalLeft()
	 * @see #getSignalsPartialDefaultDefinition()
	 * @generated
	 */
	EReference getSignalsPartialDefaultDefinition_ExprSignalLeft();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsPartialDefaultDefinition#getExprSignalRight <em>Expr Signal Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Right</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefaultDefinition#getExprSignalRight()
	 * @see #getSignalsPartialDefaultDefinition()
	 * @generated
	 */
	EReference getSignalsPartialDefaultDefinition_ExprSignalRight();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.SignalsPartialDefinition <em>Signals Partial Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Signals Partial Definition</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefinition
	 * @generated
	 */
	EClass getSignalsPartialDefinition();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsPartialDefinition#getExprSignalLeft <em>Expr Signal Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Left</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefinition#getExprSignalLeft()
	 * @see #getSignalsPartialDefinition()
	 * @generated
	 */
	EReference getSignalsPartialDefinition_ExprSignalLeft();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.SignalsPartialDefinition#getExprSignalRight <em>Expr Signal Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal Right</em>'.
	 * @see fr.inria.tea.ssme.SignalsPartialDefinition#getExprSignalRight()
	 * @see #getSignalsPartialDefinition()
	 * @generated
	 */
	EReference getSignalsPartialDefinition_ExprSignalRight();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.StateVariablesDeclaration <em>State Variables Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>State Variables Declaration</em>'.
	 * @see fr.inria.tea.ssme.StateVariablesDeclaration
	 * @generated
	 */
	EClass getStateVariablesDeclaration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.StateVariablesDeclaration#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.StateVariablesDeclaration#getType()
	 * @see #getStateVariablesDeclaration()
	 * @generated
	 */
	EReference getStateVariablesDeclaration_Type();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.StateVariablesDeclaration#getListSignal <em>List Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Signal</em>'.
	 * @see fr.inria.tea.ssme.StateVariablesDeclaration#getListSignal()
	 * @see #getStateVariablesDeclaration()
	 * @generated
	 */
	EReference getStateVariablesDeclaration_ListSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.StateVariableValue <em>State Variable Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>State Variable Value</em>'.
	 * @see fr.inria.tea.ssme.StateVariableValue
	 * @generated
	 */
	EClass getStateVariableValue();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.StateVariableValue#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.StateVariableValue#getIdentifier()
	 * @see #getStateVariableValue()
	 * @generated
	 */
	EReference getStateVariableValue_Identifier();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.StringValue <em>String Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String Value</em>'.
	 * @see fr.inria.tea.ssme.StringValue
	 * @generated
	 */
	EClass getStringValue();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.StringValue#getListConstantString <em>List Constant String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Constant String</em>'.
	 * @see fr.inria.tea.ssme.StringValue#getListConstantString()
	 * @see #getStringValue()
	 * @generated
	 */
	EReference getStringValue_ListConstantString();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TernaryOperators <em>Ternary Operators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Ternary Operators</em>'.
	 * @see fr.inria.tea.ssme.TernaryOperators
	 * @generated
	 */
	EClass getTernaryOperators();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal1 <em>Expr Signal1</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal1</em>'.
	 * @see fr.inria.tea.ssme.TernaryOperators#getExprSignal1()
	 * @see #getTernaryOperators()
	 * @generated
	 */
	EReference getTernaryOperators_ExprSignal1();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal2 <em>Expr Signal2</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal2</em>'.
	 * @see fr.inria.tea.ssme.TernaryOperators#getExprSignal2()
	 * @see #getTernaryOperators()
	 * @generated
	 */
	EReference getTernaryOperators_ExprSignal2();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TernaryOperators#getExprSignal3 <em>Expr Signal3</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal3</em>'.
	 * @see fr.inria.tea.ssme.TernaryOperators#getExprSignal3()
	 * @see #getTernaryOperators()
	 * @generated
	 */
	EReference getTernaryOperators_ExprSignal3();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Transposition <em>Transposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transposition</em>'.
	 * @see fr.inria.tea.ssme.Transposition
	 * @generated
	 */
	EClass getTransposition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TupleType <em>Tuple Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tuple Type</em>'.
	 * @see fr.inria.tea.ssme.TupleType
	 * @generated
	 */
	EClass getTupleType();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.TupleType#getListSignalsDeclaration <em>List Signals Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>List Signals Declaration</em>'.
	 * @see fr.inria.tea.ssme.TupleType#getListSignalsDeclaration()
	 * @see #getTupleType()
	 * @generated
	 */
	EReference getTupleType_ListSignalsDeclaration();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TupleType#getGraphSpecification <em>Graph Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Graph Specification</em>'.
	 * @see fr.inria.tea.ssme.TupleType#getGraphSpecification()
	 * @see #getTupleType()
	 * @generated
	 */
	EReference getTupleType_GraphSpecification();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.TupleType#getTypeKind <em>Type Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type Kind</em>'.
	 * @see fr.inria.tea.ssme.TupleType#getTypeKind()
	 * @see #getTupleType()
	 * @generated
	 */
	EAttribute getTupleType_TypeKind();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Type <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see fr.inria.tea.ssme.Type
	 * @generated
	 */
	EClass getType();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypeDefinition <em>Type Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Definition</em>'.
	 * @see fr.inria.tea.ssme.TypeDefinition
	 * @generated
	 */
	EClass getTypeDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypeDescription <em>Type Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Description</em>'.
	 * @see fr.inria.tea.ssme.TypeDescription
	 * @generated
	 */
	EClass getTypeDescription();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TypeDescription#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Identifier</em>'.
	 * @see fr.inria.tea.ssme.TypeDescription#getIdentifier()
	 * @see #getTypeDescription()
	 * @generated
	 */
	EReference getTypeDescription_Identifier();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TypeDescription#getTypeDescriptionValue <em>Type Description Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type Description Value</em>'.
	 * @see fr.inria.tea.ssme.TypeDescription#getTypeDescriptionValue()
	 * @see #getTypeDescription()
	 * @generated
	 */
	EReference getTypeDescription_TypeDescriptionValue();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TypeDescription#getInitValue <em>Init Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Init Value</em>'.
	 * @see fr.inria.tea.ssme.TypeDescription#getInitValue()
	 * @see #getTypeDescription()
	 * @generated
	 */
	EReference getTypeDescription_InitValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypeDescriptionValue <em>Type Description Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Description Value</em>'.
	 * @see fr.inria.tea.ssme.TypeDescriptionValue
	 * @generated
	 */
	EClass getTypeDescriptionValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypeMorphism <em>Type Morphism</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Morphism</em>'.
	 * @see fr.inria.tea.ssme.TypeMorphism
	 * @generated
	 */
	EClass getTypeMorphism();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TypeMorphism#getDescribedType <em>Described Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Described Type</em>'.
	 * @see fr.inria.tea.ssme.TypeMorphism#getDescribedType()
	 * @see #getTypeMorphism()
	 * @generated
	 */
	EReference getTypeMorphism_DescribedType();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.TypeMorphism#getTypeDescriptionValue <em>Type Description Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Type Description Value</em>'.
	 * @see fr.inria.tea.ssme.TypeMorphism#getTypeDescriptionValue()
	 * @see #getTypeMorphism()
	 * @generated
	 */
	EReference getTypeMorphism_TypeDescriptionValue();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypesDeclaration <em>Types Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Types Declaration</em>'.
	 * @see fr.inria.tea.ssme.TypesDeclaration
	 * @generated
	 */
	EClass getTypesDeclaration();

	/**
	 * Returns the meta object for the attribute '{@link fr.inria.tea.ssme.TypesDeclaration#getVisibility <em>Visibility</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Visibility</em>'.
	 * @see fr.inria.tea.ssme.TypesDeclaration#getVisibility()
	 * @see #getTypesDeclaration()
	 * @generated
	 */
	EAttribute getTypesDeclaration_Visibility();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.TypesDeclaration#getTypeDefinition <em>Type Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Type Definition</em>'.
	 * @see fr.inria.tea.ssme.TypesDeclaration#getTypeDefinition()
	 * @see #getTypesDeclaration()
	 * @generated
	 */
	EReference getTypesDeclaration_TypeDefinition();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.TypesOrSignalsDeclaration <em>Types Or Signals Declaration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Types Or Signals Declaration</em>'.
	 * @see fr.inria.tea.ssme.TypesOrSignalsDeclaration
	 * @generated
	 */
	EClass getTypesOrSignalsDeclaration();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.UnaryMinus <em>Unary Minus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Minus</em>'.
	 * @see fr.inria.tea.ssme.UnaryMinus
	 * @generated
	 */
	EClass getUnaryMinus();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.UnaryPlus <em>Unary Plus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Plus</em>'.
	 * @see fr.inria.tea.ssme.UnaryPlus
	 * @generated
	 */
	EClass getUnaryPlus();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.UnaryOperators <em>Unary Operators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Operators</em>'.
	 * @see fr.inria.tea.ssme.UnaryOperators
	 * @generated
	 */
	EClass getUnaryOperators();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.UnaryOperators#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.UnaryOperators#getExprSignal()
	 * @see #getUnaryOperators()
	 * @generated
	 */
	EReference getUnaryOperators_ExprSignal();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.UnaryWhen <em>Unary When</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary When</em>'.
	 * @see fr.inria.tea.ssme.UnaryWhen
	 * @generated
	 */
	EClass getUnaryWhen();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.UnconditionedDependences <em>Unconditioned Dependences</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unconditioned Dependences</em>'.
	 * @see fr.inria.tea.ssme.UnconditionedDependences
	 * @generated
	 */
	EClass getUnconditionedDependences();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.UnconditionedDependences#getSignals <em>Signals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Signals</em>'.
	 * @see fr.inria.tea.ssme.UnconditionedDependences#getSignals()
	 * @see #getUnconditionedDependences()
	 * @generated
	 */
	EReference getUnconditionedDependences_Signals();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.inria.tea.ssme.UnconditionedDependences#getDependenceElementsList <em>Dependence Elements List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dependence Elements List</em>'.
	 * @see fr.inria.tea.ssme.UnconditionedDependences#getDependenceElementsList()
	 * @see #getUnconditionedDependences()
	 * @generated
	 */
	EReference getUnconditionedDependences_DependenceElementsList();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Var <em>Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Var</em>'.
	 * @see fr.inria.tea.ssme.Var
	 * @generated
	 */
	EClass getVar();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.When <em>When</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>When</em>'.
	 * @see fr.inria.tea.ssme.When
	 * @generated
	 */
	EClass getWhen();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Window <em>Window</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Window</em>'.
	 * @see fr.inria.tea.ssme.Window
	 * @generated
	 */
	EClass getWindow();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.Xor <em>Xor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Xor</em>'.
	 * @see fr.inria.tea.ssme.Xor
	 * @generated
	 */
	EClass getXor();

	/**
	 * Returns the meta object for class '{@link fr.inria.tea.ssme.ControlledProcess <em>Controlled Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Controlled Process</em>'.
	 * @see fr.inria.tea.ssme.ControlledProcess
	 * @generated
	 */
	EClass getControlledProcess();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ControlledProcess#getExprSignal <em>Expr Signal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Signal</em>'.
	 * @see fr.inria.tea.ssme.ControlledProcess#getExprSignal()
	 * @see #getControlledProcess()
	 * @generated
	 */
	EReference getControlledProcess_ExprSignal();

	/**
	 * Returns the meta object for the containment reference '{@link fr.inria.tea.ssme.ControlledProcess#getExprProcess <em>Expr Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expr Process</em>'.
	 * @see fr.inria.tea.ssme.ControlledProcess#getExprProcess()
	 * @see #getControlledProcess()
	 * @generated
	 */
	EReference getControlledProcess_ExprProcess();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.ConstantLogicalKind <em>Constant Logical Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Constant Logical Kind</em>'.
	 * @see fr.inria.tea.ssme.ConstantLogicalKind
	 * @generated
	 */
	EEnum getConstantLogicalKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.IntervalsKind <em>Intervals Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Intervals Kind</em>'.
	 * @see fr.inria.tea.ssme.IntervalsKind
	 * @generated
	 */
	EEnum getIntervalsKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.ModelKind <em>Model Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Model Kind</em>'.
	 * @see fr.inria.tea.ssme.ModelKind
	 * @generated
	 */
	EEnum getModelKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.OperatorKind <em>Operator Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Operator Kind</em>'.
	 * @see fr.inria.tea.ssme.OperatorKind
	 * @generated
	 */
	EEnum getOperatorKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.ProcessAttributeKind <em>Process Attribute Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Process Attribute Kind</em>'.
	 * @see fr.inria.tea.ssme.ProcessAttributeKind
	 * @generated
	 */
	EEnum getProcessAttributeKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.SignalIntrinsicType <em>Signal Intrinsic Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Signal Intrinsic Type</em>'.
	 * @see fr.inria.tea.ssme.SignalIntrinsicType
	 * @generated
	 */
	EEnum getSignalIntrinsicType();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.TypeKind <em>Type Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Type Kind</em>'.
	 * @see fr.inria.tea.ssme.TypeKind
	 * @generated
	 */
	EEnum getTypeKind();

	/**
	 * Returns the meta object for enum '{@link fr.inria.tea.ssme.VisibilityKind <em>Visibility Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Visibility Kind</em>'.
	 * @see fr.inria.tea.ssme.VisibilityKind
	 * @generated
	 */
	EEnum getVisibilityKind();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SsmeFactory getSsmeFactory();

} //SsmePackage
